//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
i_masterbalancesis.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function lanzar()
  {
    return this.ctx.lanzar1();
  }
  function cargarQryReport(cursor: FLSqlCursor, idImpresion: String)
  {
    return this.ctx.cargarQryReport2(cursor, idImpresion);
  }
  function rellenarDatos(idImpresion: String, cursor: FLSqlCursor)
  {
    return this.ctx.rellenarDatos3(idImpresion, cursor);
  }
  function quitarAsientos(codEjercicio: String)
  {
    return this.ctx.quitarAsientos4(codEjercicio);
  }
  //  function crearNodoRow() {
  //    return this.ctx.oficial_crearNodoRow();
  //  }
  //  function dameNodoXML(nodoPadre:FLDomNode, ruta:String, debeExistir:Boolean) {
  //    return this.ctx.oficial_dameNodoXML(nodoPadre, ruta, debeExistir);
  //  }
  function lanzar()
  {
    return this.ctx.lanzar5();
  }
  function datosInforme(nombrebd: String, codEjercicio: String, fechaDesde: String, fechaHasta: String, subcuentaDesde: String, subcuentaHasta: String)
  {
    return this.ctx.datosInforme6(nombrebd, codEjercicio, fechaDesde, fechaHasta, subcuentaDesde, subcuentaHasta);
  }
  function pub_cargarQryReport(cursor: FLSqlCursor, idImpresion: String)
  {
    return this.cargarQryReport(cursor, idImpresion);
  }
}
const iface = new interna(this);
/** \C El botn de impresin lanza el informe
\end */
function init0()
{
  connect(this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
/** \D Lanza el informe
Se hacen algunas modificacione sobre la consulta del informe:
Se aade un GROUP BY para calcular la suma de saldos de las subcuentas agrupadas por cuenta. Si se marca la opcin de consolidar ejercicio, se aaden al WHERE de la consulta los datos del ejercicio anterior para que tambin sean sumados en el informe resultante.
\end */
function lanzar1()
{
  var util = new FLUtil;
  var cursor = this.cursor()
               if (!cursor.isValid())
                 return;
  flcontinfo.iface.numPag = 0;
  var ahora = new Date;
  var idImpresion = ahora.getTime().toString();
  idImpresion += sys.nameUser();
  var datos = this.iface.cargarQryReport(cursor, idImpresion);
  if (!datos) {
    return false;
  }
  var q = datos["query"];
  var nombreReport = datos["report"];
  var rptViewer = new FLReportViewer();
  rptViewer.setReportTemplate(nombreReport);
  rptViewer.setReportData(q);
  rptViewer.renderReport();
  rptViewer.exec();
  if (!util.sqlDelete("co_i_balancesis_buffer", "idimpresion = '" + idImpresion + "'")) {
    return;
  }
}
function cargarQryReport2(cursor: FLSqlCursor, idImpresion: String)
{
  var util = new FLUtil();
  var nombreInforme = cursor.table();
  var nombreReport = nombreInforme;
  var datos: Array;
  if (cursor.valueBuffer("resumido"))
    nombreReport = "co_i_balancesis_res";
  if (cursor.valueBuffer("nivel") == "Subcuenta")
    nombreReport = "co_i_balancesis_scta";
  flcontinfo.iface.pub_establecerInformeActual(cursor.valueBuffer("id"), nombreInforme);
  this.iface.rellenarDatos(idImpresion, cursor);
  var q = new FLSqlQuery(nombreInforme);
  q.setWhere("idimpresion = '" + idImpresion + "'");
  if (!q.exec()) {
    MessageBox.critical(util.translate("scripts", "Fall la consulta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return;
  }
  if (!q.size()) {
    MessageBox.warning(util.translate("scripts", "No hay registros que cumplan los criterios de bsqueda establecidos"), MessageBox.NoButton);
    return;
  }
  datos["query"] = q;
  datos["report"] = nombreReport;
  return datos;
}
function rellenarDatos3(idImpresion: String, cursor: FLSqlCursor)
{
  var util = new FLUtil;
  var groupBy = "co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion";
  var orderBy = "co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion";
  var ejAct = cursor.valueBuffer("i_co__subcuentas_codejercicio");
  var desdeAct = cursor.valueBuffer("d_co__asientos_fecha");
  var hastaAct = cursor.valueBuffer("h_co__asientos_fecha");
  var desdeScta = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
  var hastaScta = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
  var nivel: Number
  // Subcuenta por compatibilidad hacia atras
  if (cursor.valueBuffer("nivel") == "Cuenta" || cursor.valueBuffer("nivel") == "Subcuenta")
    nivel = 0;
  else
    nivel = parseFloat(cursor.valueBuffer("nivel"));
  var where = "(co_asientos.codejercicio = '" + ejAct + "'" +
              " AND co_asientos.fecha >= '" + desdeAct + "'" +
              " AND co_asientos.fecha <= '" + hastaAct + "'";
  if (desdeScta)
    where += " AND co_partidas.codsubcuenta >= '" + desdeScta + "'";
  if (hastaScta)
    where += " AND co_partidas.codsubcuenta <= '" + hastaScta + "'";
  var listaAsientos = this.iface.quitarAsientos(ejAct);
  if (listaAsientos && listaAsientos != "") {
    where += " AND co_asientos.idasiento NOT IN (" + listaAsientos + ")";
  }
  where += ")";
  var consolidar = false;
  if (cursor.valueBuffer("ejercicioanterior") == 1)
    consolidar = true;
  if (consolidar) {
    var ejAnt = cursor.valueBuffer("codejercicioant");
    var desdeAnt = cursor.valueBuffer("fechaant_d");
    var hastaAnt = cursor.valueBuffer("fechaant_h");
    desdeScta = cursor.valueBuffer("d_co__subcuentas_codsubcuenta");
    hastaScta = cursor.valueBuffer("h_co__subcuentas_codsubcuenta");
    where +=  " OR (co_asientos.codejercicio = '" + ejAnt + "'" +
              " AND co_asientos.fecha >= '" + desdeAnt + "'" +
              " AND co_asientos.fecha <= '" + hastaAnt + "'" +
              " AND co_partidas.codsubcuenta >= '" + desdeScta + "'" +
              " AND co_partidas.codsubcuenta <= '" + hastaScta + "'";
    var listaAsientosAnt = this.iface.quitarAsientos(ejAnt);
    if (listaAsientosAnt && listaAsientosAnt != "") {
      where += " AND co_asientos.idasiento NOT IN (" + listaAsientos + ")";
    }
    where += ")";
  }
  var q = new FLSqlQuery();
  q.setTablesList("co_cuentas,co_subcuentas,co_partidas,co_asientos");
  q.setFrom("co_cuentas INNER JOIN co_subcuentas ON co_cuentas.idcuenta = co_subcuentas.idcuenta INNER JOIN co_partidas ON co_subcuentas.idsubcuenta = co_partidas.idsubcuenta INNER JOIN co_asientos ON co_partidas.idasiento = co_asientos.idasiento");
  q.setSelect("co_cuentas.codcuenta, co_cuentas.descripcion, co_subcuentas.codsubcuenta, co_subcuentas.descripcion, SUM(co_partidas.debe), SUM(co_partidas.haber), SUM(co_partidas.debe)-SUM(co_partidas.haber)");
  q.setWhere(where + " group by " + groupBy + " ORDER BY " + orderBy);
  if (!q.exec()) {
    MessageBox.critical(util.translate("scripts", "Fall la consulta"),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return;
  }
  util.createProgressDialog(util.translate("scripts", "Recabando datos..."), q.size());
  var codCuenta: String;
  var curTab = new FLSqlCursor("co_i_balancesis_buffer");
  var paso = 0;
  //  var xmlKD= new FLDomDocument;
  //  xmlKD.setContent("<!DOCTYPE KUGAR_DATA><KugarData/>");
  //  var nodoRow:FLDomNode;
  //  var eRow:FLDomElement;
  var debe: Number, haber: Number, saldo: Number;
  var codCuentaAnt = "";
  while (q.next()) {
    util.setProgress(paso++);
    debe = util.roundFieldValue(q.value(4), "co_subcuentas", "debe");
    haber = util.roundFieldValue(q.value(5), "co_subcuentas", "haber")
            saldo = util.roundFieldValue(q.value(6), "co_subcuentas", "saldo")
                    codSubcuenta = q.value(2);
    if (nivel == 0) {
      codCuenta = q.value(0);
    } else {
      codCuenta = codSubcuenta.left(nivel);
    }
    switch (nivel) {
      case 0:
        descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
        break;
      case 2:
        descCuenta = util.sqlSelect("co_epigrafes", "descripcion", "codepigrafe = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
        break;
      case 3:
        descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta + "%' AND codejercicio = '" + ejAct + "'");
        break;
      case 4:
      case 5:
        descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta = '" + codCuenta + "' AND codejercicio = '" + ejAct + "'");
        if (!descCuenta)
          descCuenta = util.sqlSelect("co_cuentas", "descripcion", "codcuenta LIKE '" + codCuenta.left(3) + "%' AND codejercicio = '" + ejAct + "'");
        break;
    }
    if (!descCuenta)
      descCuenta = q.value(3);
    curTab.select("idimpresion = '" + idImpresion + "' AND codsubcuenta = '" + codSubcuenta + "'");
    //    nodoRow = this.iface.dameNodoXML(xmlKD.firstChild(), "Row[@co_i_balancesis_buffer.codsubcuenta=" + codSubcuenta + "]");
    if (curTab.first()/* && nodoRow*/) {
      /// Con tabla
      curTab.setModeAccess(curTab.Edit);
      curTab.refreshBuffer();
      curTab.setValueBuffer("debe", parseFloat(curTab.valueBuffer("debe")) + parseFloat(debe));
      curTab.setValueBuffer("haber", parseFloat(curTab.valueBuffer("haber")) + parseFloat(haber));
      curTab.setValueBuffer("saldo", parseFloat(curTab.valueBuffer("saldo")) + parseFloat(saldo));
      /// Con XML
      //      eRow = nodoRow.toElement();
      //      eRow.setAttribute("co_i_balancesis_buffer.debe", parseFloat(eRow.attribute("co_i_balancesis_buffer.debe")) + parseFloat(debe));
      //      eRow.setAttribute("co_i_balancesis_buffer.haber", parseFloat(eRow.attribute("co_i_balancesis_buffer.haber")) + parseFloat(haber));
      //      eRow.setAttribute("co_i_balancesis_buffer.saldo", parseFloat(eRow.attribute("co_i_balancesis_buffer.saldo")) + parseFloat(saldo));
    } else {
      /// Con tabla
      curTab.setModeAccess(curTab.Insert);
      curTab.refreshBuffer();
      curTab.setValueBuffer("idimpresion", idImpresion);
      curTab.setValueBuffer("codsubcuenta", codSubcuenta);
      curTab.setValueBuffer("codcuenta", codCuenta);
      curTab.setValueBuffer("descripcion", q.value(3));
      curTab.setValueBuffer("descripcioncuenta", descCuenta);
      curTab.setValueBuffer("debe", debe);
      curTab.setValueBuffer("haber", haber);
      curTab.setValueBuffer("saldo", saldo);
      /// Con XML
      //      if (codCuenta != codCuentaAnt) {
      //        level = 0;
      //      } else {
      //        level = 1;
      //        codCuenta = codCuentaAnt;
      //      }
      //      nodoRow = this.iface.crearNodoRow();
      //      xmlKD.firstChild().appendChild(nodoRow);
      //      eRow = nodoRow.toElement();
      //      eRow.setAttribute("empresa.nombre", flfactppal.iface.valorDefectoEmpresa("nombre"));
      //      eRow.setAttribute("co_i_balancesis_buffer.codcuenta", codCuenta);
      //      eRow.setAttribute("co_i_balancesis_buffer.codsubcuenta", codSubcuenta);
      //      eRow.setAttribute("co_i_balancesis_buffer.descripcion", q.value(3));
      //      eRow.setAttribute("co_i_balancesis_buffer.descripcioncuenta", descCuenta);
      //      eRow.setAttribute("co_i_balancesis_buffer.debe", debe);
      //      eRow.setAttribute("co_i_balancesis_buffer.haber", haber);
      //      eRow.setAttribute("co_i_balancesis_buffer.saldo", saldo);
      //      eRow.setAttribute("level", level);
      //      if (level == 0) {
      //        var nodoL1= nodoRow.cloneNode();
      //        nodoL1.toElement().setAttribute("level", 1);
      //        xmlKD.firstChild().appendChild(nodoL1);
      //      }
    }
    curTab.commitBuffer();
  }
  util.destroyProgressDialog();
  //  return xmlKD;
}
// function oficial_crearNodoRow()
// {
//  var xmlRow= new FLDomDocument;
//  xmlRow.setContent("<Row/>");
//  return xmlRow.firstChild();
// }
function quitarAsientos4(codEjercicio: String)
{
  var util = new FLUtil;
  var cursor = this.cursor();
  var listaAsientos = "";
  var asientoPyG: String;
  var asientoCierre: String;
  if (cursor.valueBuffer("ignorarcierre")) {
    asientoPyG = util.sqlSelect("ejercicios", "idasientopyg", "codejercicio = '" + codEjercicio + "'");
    if (!asientoPyG) {
      asientoPyG = -1;
    }
    asientoCierre = util.sqlSelect("ejercicios", "idasientocierre", "codejercicio = '" + cursor.valueBuffer("i_co__subcuentas_codejercicio") + "'");
    if (!asientoCierre) {
      asientoCierre = -1;
    }
    listaAsientos += asientoPyG + ", "  + asientoCierre;
  }
  return listaAsientos;
}
/** \C Busca un nodo en un nodo y sus nodos hijos
@param  nodoPadre: Nodo que contiene el nodo a buscar (o los nodos hijos que lo contienen)
@param  ruta: Cadena que especifica la ruta a seguir para encontrar el atributo. Su formato es NodoPadre/NodoHijo/NodoNieto/.../Nodo. Puede ser tan larga como sea necesario. Siempre se toma el primer nodo Hijo que tiene el nombre indicado.
@param  debeExistir: Si vale true la funcin devuelve false si no encuentra el atributo
@return Nodo buscado o false si hay error o no se encuentra el nodo
\end */
// function oficial_dameNodoXML(nodoPadre:FLDomNode, ruta:String, debeExistir:Boolean)
// {
//  var util= new FLUtil;
//
//  var valor:String;
//  var nombreNodo= ruta.split("/");
//  var nodoXML= nodoPadre;
//  var i:Number;
//  var nombreActual:String;
//  var iInicioCorchete:Number
//  for (i = 0; i < nombreNodo.length; i++) {
//    nombreActual = nombreNodo[i];
//    iInicioCorchete = nombreActual.find("[");
//    if (iInicioCorchete > -1) {
//      iFinCorchete = nombreActual.find("]");
//      var condicion= nombreActual.substring(iInicioCorchete + 1, iFinCorchete);
//      var paramCond= condicion.split("=");
//      if (!paramCond[0].startsWith("@")) {
//        MessageBox.warning(util.translate("scripts", "Error al procesar la ruta XML %1 en %2").arg(ruta).arg(nombreActual), MessageBox.Ok, MessageBox.NoButton);
//        return false;
//      }
//      nombreActual = nombreActual.left(iInicioCorchete);
//      var atributo= paramCond[0].right(paramCond[0].length - 1);
//      var nodoHijo:FLDomNode;
//      for (nodoHijo = nodoXML.firstChild(); nodoHijo; nodoHijo = nodoHijo.nextSibling()) {
//        if (nodoHijo.nodeName() == nombreActual && nodoHijo.toElement().attribute(atributo) == paramCond[1]) {
//          break;
//        }
//      }
//      if (nodoHijo) {
//        nodoXML = nodoHijo;
//      } else {
//        if (debeExistir) {
//          MessageBox.warning(util.translate("scripts", "No se encontr el nodo en la ruta ruta %1").arg(ruta), MessageBox.Ok, MessageBox.NoButton);
//        }
//        return false;
//      }
//    } else {
//      nodoXML = nodoXML.namedItem(nombreActual)
//      if (!nodoXML) {
//        if (debeExistir) {
//          MessageBox.warning(util.translate("scripts", "No se pudo leer el nodo de la ruta:\n%1.\nNo se encuentra el nodo <%2>").arg(ruta).arg(nombreNodo[i]), MessageBox.Ok, MessageBox.NoButton);
//        }
//        return false;
//      }
//    }
//  }
//  return nodoXML;
// }
/** \D
Se recaban datos para el balance de varias empresas, se introducen en la tabla buffer y se lanza el informe sobre la nueva tabla
\end */
function lanzar5()
{
  var util = new FLUtil;
  var cursor = this.cursor()
               if (!cursor.isValid())
                 return;
  // Si es consolidado con la empresa actual, lanzamos el informe normal
  if (cursor.valueBuffer("ejercicioanterior"))
    return this.iface.__lanzar();
  // Si no hay otras empresas lanzamos el informe normal
  if (!util.sqlSelect("co_ejerciciosempresas_sis", "id", "idbalance = " + cursor.valueBuffer("id"))) {
    return this.iface.__lanzar();
  }
  // Vaciar el buffer
  flcontinfo.iface.pub_vaciarBuffer("co_i_balancesis_bmulti_buffer");
  // Recabar datos de esta empresa
  this.iface.datosInforme(sys.nameBD(), cursor.valueBuffer("i_co__subcuentas_codejercicio"), cursor.valueBuffer("d_co__asientos_fecha"), cursor.valueBuffer("h_co__asientos_fecha"), cursor.valueBuffer("d_co__subcuentas_codsubcuenta"), cursor.valueBuffer("h_co__subcuentas_codsubcuenta"));
  // Recabar datos del resto de empresas
  var curTab = new FLSqlCursor("co_ejerciciosempresas_sis");
  curTab.select("idbalance = " + cursor.valueBuffer("id"));
  while (curTab.next())
    this.iface.datosInforme(curTab.valueBuffer("nombrebd"), curTab.valueBuffer("codejercicio"), curTab.valueBuffer("fechadesde"), curTab.valueBuffer("fechahasta"), cursor.valueBuffer("d_co__subcuentas_codsubcuenta"), cursor.valueBuffer("h_co__subcuentas_codsubcuenta"));
  flcontinfo.iface.pub_establecerInformeActual(cursor.valueBuffer("id"), "co_i_balancesis");
  // Lanzar el informe
  var nombreInforme = "co_i_balancesis_multi";
  var nombreReport = nombreInforme;
  var groupBy = "b.codcuenta,b.desccuenta,b.codsubcuenta,b.descsubcuenta";
  var q = new FLSqlQuery(nombreInforme);
  q.setWhere("1=1 GROUP BY " + groupBy);
  if (!q.exec()) {
    MessageBox.critical(util.translate("scripts", "Fall la consulta"),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
  }
  if (cursor.valueBuffer("nivel") == util.translate("scripts", "Cuenta"))
    nombreReport = "co_i_balancesis_res_multi";
  var rptViewer = new FLReportViewer();
  rptViewer.setReportTemplate(nombreReport);
  rptViewer.setReportData(q);
  util.destroyProgressDialog();
  rptViewer.renderReport();
  rptViewer.exec();
}
/** \D
Se recaban datos para el balance de varias empresas, se introducen en la tabla buffer y se lanza el informe sobre la nueva tabla
\end */
function datosInforme6(nombrebd: String, codEjercicio: String, fechaDesde: String, fechaHasta: String, subcuentaDesde: String, subcuentaHasta: String)
{
  var util = new FLUtil;
  var cursor = this.cursor()
               var asientoPyG: String;
  var asientoCierre: String;
  var groupBy = "co_cuentas.codcuenta," +
                "co_cuentas.descripcion, co_subcuentas.idsubcuenta, co_subcuentas.codsubcuenta,"
                + "co_subcuentas.descripcion, co_subcuentas.codcuenta";
  var where = "co_asientos.codejercicio = '" + codEjercicio + "'";
  if (fechaDesde)
    where += " AND co_asientos.fecha >= '" + fechaDesde + "'";
  if (fechaHasta)
    where += " AND co_asientos.fecha <= '" + fechaHasta + "'";
  if (subcuentaDesde)
    where += " AND co_partidas.codsubcuenta >= '" + subcuentaDesde + "'";
  if (subcuentaHasta)
    where += " AND co_partidas.codsubcuenta <= '" + subcuentaHasta + "'";
  if (cursor.valueBuffer("ignorarcierre")) {
    asientoPyG = util.sqlSelect("ejercicios", "idasientopyg", "codejercicio = '" + codEjercicio + "'");
    if (!asientoPyG)
      asientoPyG = -1;
    asientoCierre = util.sqlSelect("ejercicios", "idasientocierre", "codejercicio = '" + codEjercicio + "'");
    if (!asientoCierre)
      asientoCierre = -1;
    where += " AND co_asientos.idasiento NOT IN (" + asientoPyG + ", "  + asientoCierre + ")";
  }
  // Conectamos
  var q: FLSqlQuery;
  if (nombrebd != sys.nameBD()) {
    var conexion = nombrebd + "_conn";
    if (!flcontinfo.iface.pub_conectar(nombrebd))
      return;
    q = new FLSqlQuery("co_i_balancesis_bmulti", conexion);
  } else
    q = new FLSqlQuery("co_i_balancesis_bmulti");
  q.setWhere(where + " GROUP BY " + groupBy);
  var curTab = new FLSqlCursor("co_i_balancesis_bmulti_buffer");
  if (!q.exec()) {
    MessageBox.critical(util.translate("scripts", "Fall la consulta"),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
  }
  var paso = 0;
  util.createProgressDialog(util.translate("scripts", "Recabando datos de ") + nombrebd, q.size());
  while (q.next()) {
    curTab.setModeAccess(curTab.Insert);
    curTab.refreshBuffer();
    curTab.setValueBuffer("codejercicio", codEjercicio);
    curTab.setValueBuffer("nombrebd", nombrebd);
    curTab.setValueBuffer("codcuenta", q.value(0));
    curTab.setValueBuffer("desccuenta", q.value(1));
    curTab.setValueBuffer("codsubcuenta", q.value(2));
    curTab.setValueBuffer("descsubcuenta", q.value(3));
    curTab.setValueBuffer("debe", q.value(4));
    curTab.setValueBuffer("haber", q.value(5));
    curTab.setValueBuffer("saldo", q.value(6));
    curTab.commitBuffer();
    util.setProgress(paso++);
  }
  util.destroyProgressDialog();
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
