//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
i_masterbalancepyg.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var totalRecargoEq_: Number;
  var totalIvaMasRecargoEq_: Number;
  var ultRecargoEq_: Number;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function lanzar()
  {
    return this.ctx.lanzar1();
  }
  function recargoEq(nodo: FLDomNode, campo: String)
  {
    return this.ctx.recargoEq2(nodo, campo);
  }
  function totalRecargoEq(nodo: FLDomNode, campo: String)
  {
    return this.ctx.totalRecargoEq3(nodo, campo);
  }
  function ivaMasRecargoEq(nodo: FLDomNode, campo: String)
  {
    return this.ctx.ivaMasRecargoEq4(nodo, campo);
  }
  function totalIvaMasRecargoEq(nodo: FLDomNode, campo: String)
  {
    return this.ctx.totalIvaMasRecargoEq5(nodo, campo);
  }
  function initReport(nodo: FLDomNode, campo: String)
  {
    return this.ctx.initReport6(nodo, campo);
  }
  function dameMasWhere()
  {
    return this.ctx.dameMasWhere7();
  }
  function dameOrderBy()
  {
    return this.ctx.dameOrderBy8();
  }
  function pub_recargoEq(nodo: FLDomNode, campo: String)
  {
    return this.recargoEq(nodo, campo);
  }
  function pub_totalRecargoEq(nodo: FLDomNode, campo: String)
  {
    return this.totalRecargoEq(nodo, campo);
  }
  function pub_ivaMasRecargoEq(nodo: FLDomNode, campo: String)
  {
    return this.ivaMasRecargoEq(nodo, campo);
  }
  function pub_totalIvaMasRecargoEq(nodo: FLDomNode, campo: String)
  {
    return this.totalIvaMasRecargoEq(nodo, campo);
  }
  function pub_initReport(nodo: FLDomNode, campo: String)
  {
    return this.initReport(nodo, campo);
  }
}
const iface = new interna(this);
/** \C El botn de impresin lanza el informe
\end */
function init0()
{
  connect(this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
/** \D Lanza el informe. Aade al WHERE de la consulta la condicin de que slo se muestren las partidas cuya subcuenta pertenece a una cuenta de tipo especial de I.V.A. repercutido.
\end */
function lanzar1()
{
  var cursor = this.cursor()
  if (!cursor.isValid()) {
    return;
  }
  var nombreInforme = cursor.action();
  var nombreReport = nombreInforme;
  if (cursor.valueBuffer("numeracionauto")) {
    /// nombreReport = nombreReport + "_n"; Ya ne se usa el informe _n, se usa un campo calculado en el informe normal
    flcontinfo.iface.pub_resetearNumFactura(parseFloat(cursor.valueBuffer("numdesde")));
  } else {
    flcontinfo.iface.pub_resetearNumFactura(parseFloat(-1));
  }
  var masWhere = this.iface.dameMasWhere();
  var orderBy = this.iface.dameOrderBy();
  flcontinfo.iface.pub_lanzarInforme(cursor, nombreInforme, nombreReport, orderBy, "", masWhere, cursor.valueBuffer("id"));
}
function dameOrderBy8()
{
  var cursor = this.cursor();
  var orderBy = "";
  var numeracionAuto = cursor.valueBuffer("numeracionauto");
  if (numeracionAuto) {
    orderBy = "co_partidas.codserie, co_asientos.fecha, co_partidas.idasiento";
  } else {
    orderBy = "co_partidas.codserie, co_partidas.factura, co_asientos.fecha, co_partidas.idasiento";
  }
  return orderBy;
}
function dameMasWhere7()
{
  var cursor = this.cursor();
  var masWhere = "";
  var conIva = cursor.valueBuffer("coniva");
  masWhere = " AND sc1.idcuentaesp IN ('IVAREP', 'IVAEUE', 'IVARXP', 'IVAREX')";
  if (conIva) {
    masWhere += " AND co_partidas.iva <> 0";
    masWhere += " AND (series.siniva IS NULL OR series.siniva = false)";
  }
  return masWhere;
}
/** \D Obtiene el recargo de equivalencia de la partida asociada a la cuenta IVAACR del asiento considerado
\end */
function recargoEq2(nodo: FLDomNode, campo: String)
{
  var util = new FLUtil;
  var idAsiento = nodo.attributeValue("co_asientos.idasiento");
  var porIva = nodo.attributeValue("co_partidas.iva");
  var porRe = nodo.attributeValue("co_partidas.recargo");
  var valor: Number;
  var numRecargo = parseFloat(porRe);
  if (!isNaN(numRecargo) && numRecargo != 0) {
    // El IN (iva, 0) se coloca para que el informe funcione correctamente con flfacturac 2.0, donde no se gualdaban los datos de IVA y recargo en cada partida de recargo de equivalencia
    valor = util.sqlSelect("co_partidas p INNER JOIN co_subcuentas s ON p.idsubcuenta = s.idsubcuenta INNER JOIN co_cuentasesp e ON s.codsubcuenta = e.codsubcuenta", "p.haber - p.debe", "idasiento = " + idAsiento + " AND e.idcuentaesp IN ('IVAACR', 'IVARRE') AND p.iva IN (" + porIva + ", 0) AND p.recargo IN (" + porRe + ", 0)", "co_partidas,co_subcuentas,co_cuentasesp");
    if (!valor) {
      valor = util.sqlSelect("co_partidas p INNER JOIN co_subcuentas s ON p.idsubcuenta = s.idsubcuenta INNER JOIN co_cuentas c ON s.idcuenta = c.idcuenta", "p.haber - p.debe", "idasiento = " + idAsiento + " AND s.idcuentaesp IN ('IVAACR', 'IVARRE') AND p.iva IN (" + porIva + ", 0) AND p.recargo IN (" + porRe + ", 0)", "co_partidas,co_subcuentas,co_cuentas");
    }
  }
  if (!valor) {
    valor = 0;
  }
  this.iface.ultRecargoEq_ = parseFloat(valor);
  this.iface.totalRecargoEq_ += parseFloat(valor);
  return valor;
}
/** \D Obtiene la suma de IVA ms el recargo de equivalencia calculado previamente con la funcin recargoEq
\end */
function ivaMasRecargoEq4(nodo: FLDomNode, campo: String)
{
  var util = new FLUtil;
  var iva = parseFloat(nodo.attributeValue("(co_partidas.haber - co_partidas.debe)"));
  var baseImponible = parseFloat(nodo.attributeValue("co_partidas.baseimponible"));
  var valor = baseImponible + iva + this.iface.ultRecargoEq_;
  this.iface.totalIvaMasRecargoEq_ += valor;
  return valor;
}
function initReport6(nodo: FLDomNode, campo: String)
{
  this.iface.ultRecargoEq_ = 0;
  this.iface.totalRecargoEq_ = 0;
  this.iface.totalIvaMasRecargoEq_ = 0;
}
function totalRecargoEq3(nodo: FLDomNode, campo: String)
{
  return this.iface.totalRecargoEq_;
}
function totalIvaMasRecargoEq5(nodo: FLDomNode, campo: String)
{
  return this.iface.totalIvaMasRecargoEq_;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
