//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
i_masterbalancepyg.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function lanzar()
  {
    return this.ctx.lanzar1();
  }
  function dameMasWhere()
  {
    return this.ctx.dameMasWhere2();
  }
  function dameOrderBy()
  {
    return this.ctx.dameOrderBy3();
  }
}
const iface = new interna(this);
/** \C El botn de impresin lanza el informe
\end */
function init0()
{
  connect(this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
/** \D Lanza el informe. Aade al WHERE de la consulta la condicin de que slo se muestren las partidas cuya subcuenta pertenece a una cuenta de tipo especial de I.V.A. soportado.
\end */
function lanzar1()
{
  var cursor = this.cursor()
  if (!cursor.isValid()) {
    return;
  }
  var nombreInforme = cursor.action();
  var nombreReport = nombreInforme;
  var numeracionAuto = cursor.valueBuffer("numeracionauto");
  if (numeracionAuto) {
    /// nombreReport = nombreReport + "_n"; Ya ne se usa el informe _n, se usa un campo calculado en el informe normal
    flcontinfo.iface.pub_resetearNumFactura(parseFloat(cursor.valueBuffer("numdesde")));
  } else {
    flcontinfo.iface.pub_resetearNumFactura(parseFloat(-1));
  }
  var masWhere = this.iface.dameMasWhere();
  var orderBy = this.iface.dameOrderBy();
  flcontinfo.iface.pub_lanzarInforme(cursor, nombreInforme, nombreReport, orderBy, "", masWhere, cursor.valueBuffer("id"));
}
function dameOrderBy3()
{
  var cursor = this.cursor();
  var orderBy = "";
  var numeracionAuto = cursor.valueBuffer("numeracionauto");
  if (numeracionAuto) {
    orderBy = "co_partidas.codserie, co_asientos.fecha, co_partidas.idasiento";
  } else {
    orderBy = "co_partidas.codserie, co_partidas.factura, co_asientos.fecha, co_partidas.idasiento";
  }
  return orderBy;
}
function dameMasWhere2()
{
  var cursor = this.cursor();
  var masWhere = "";
  var codSerie = cursor.valueBuffer("codserie");
  var conIva = cursor.valueBuffer("coniva");
  masWhere = " AND sc1.idcuentaesp IN ('IVASOP', 'IVARUE', 'IVASUE', 'IVASIM', 'IVASEX', 'IVASRA')";
  if (codSerie) {
    masWhere += " AND co_partidas.codserie = '" + codSerie + "'";
  }
  if (conIva) {
    masWhere += " AND co_partidas.iva <> 0";
  }
  return masWhere;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
