//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
i_masteralbaranesprov.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var saldoAcumulado: Number;
  var ultimaSubcuenta: Number;
  var calcularSaldoInicial: Boolean;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function lanzar()
  {
    return this.ctx.lanzar1();
  }
  function obtenerOrden(nivel: Number, cursor: FLSqlCursor)
  {
    return this.ctx.obtenerOrden2(nivel, cursor);
  }
  function subTotalMayor(nodo: FLDomNode, campo: String)
  {
    return this.ctx.subTotalMayor3(nodo, campo);
  }
  function saldoInicial(nodo: FLDomNode, campo: String)
  {
    return this.ctx.saldoInicial4(nodo, campo);
  }
  function saldoActual(nodo: FLDomNode, campo: String)
  {
    return this.ctx.saldoActual5(nodo, campo);
  }
  function pub_subTotalMayor(nodo: FLDomNode, campo: String)
  {
    return this.subTotalMayor(nodo, campo);
  }
  function pub_saldoInicial(nodo: FLDomNode, campo: String)
  {
    return this.saldoInicial(nodo, campo);
  }
  function pub_saldoActual(nodo: FLDomNode, campo: String)
  {
    return this.saldoActual(nodo, campo);
  }
}
const iface = new interna(this);
/** \C El botn de impresin lanza el informe
\end */
function init0()
{
  connect(this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
/** \D Lanza el informe
\end */
function lanzar1()
{
  var cursor = this.cursor();
  if (!cursor.isValid())
    return;
  this.iface.ultimaSubcuenta = 0;
  this.iface.calcularSaldoInicial = cursor.valueBuffer("saldoinicial");
  var nombreInforme = cursor.action();
  /** \D Se aade un ORDER BY a la consulta en funcin de los niveles de ordenamiento seleccionados
  \end */
  var orderBy = "";
  var o = "";
  for (var i = 1; i <= 1; i++) {
    o = this.iface.obtenerOrden(i, cursor);
    if (o) {
      if (orderBy == "")
        orderBy = o;
      else
        orderBy += ", " + o;
    }
  }
  flcontinfo.iface.pub_lanzarInforme(cursor, nombreInforme, "", orderBy, "", "", cursor.valueBuffer("id"));
}
/** \D Devuelve un criterio de orden para el informe en base a su nivel. Si el orden est marcado como descendente, se aade DESC al valor devuelto. Se utiliza para crear la clusula ORDER BY de la consulta del informe
@param nivel Nivel de ordenamiento (1, 2 ...)
@param cursor Cursor sobre la tabla de informes de mayor
@return Criterio de ordenacin (y opcionalmente DESC).
*/
function obtenerOrden2(nivel: Number, cursor: FLSqlCursor)
{
  var ret = "co_subcuentas.codsubcuenta";
  var orden = cursor.valueBuffer("orden" + nivel.toString());
  var descAsc = "";
  var tipoOrden = cursor.valueBuffer("tipoorden" + nivel.toString());
  if (tipoOrden == "Descendente") {
    descAsc = " DESC";
  }
  switch (orden) {
    case "Asiento": {
      ret += ", co_asientos.numero " + descAsc;
      break;
    }
    case "Fecha": {
      ret += ", co_asientos.fecha " + descAsc + ", co_asientos.numero";
      break;
    }
  }
  return ret;
}
function subTotalMayor3(nodo: FLDomNode, campo: String)
{
  /*
  var idSubcuenta= nodo.attributeValue("co_subcuentas.idsubcuenta");
  if (idSubcuenta != this.iface.ultimaSubcuenta) {
  this.iface.saldoAcumulado = 0;
  this.iface.ultimaSubcuenta = idSubcuenta;
  }
  */
  var debe = nodo.attributeValue("co_partidas.debe");
  var haber = nodo.attributeValue("co_partidas.haber");
  this.iface.saldoAcumulado += debe - haber;
  return this.iface.saldoAcumulado;
}
function saldoInicial4(nodo: FLDomNode, campo: String)
{
  if (!this.iface.calcularSaldoInicial) {
    this.iface.saldoAcumulado = 0;
    return 0;
  }
  var util: FLUtil;
  var idSubcuenta = nodo.attributeValue("co_subcuentas.idsubcuenta");
  var fecha = nodo.attributeValue("co_asientos.fecha");
  var saldoInicial = util.sqlSelect("co_partidas p INNER JOIN co_asientos a ON p.idasiento = a.idasiento", "SUM(debe) - SUM(haber)", "p.idsubcuenta = " + idSubcuenta + " AND a.fecha < '" + fecha + "'", "co_partidas,co_asientos");
  if (!saldoInicial)
    saldoInicial = 0;
  this.iface.saldoAcumulado = saldoInicial;
  return saldoInicial;
}
function saldoActual5(nodo: FLDomNode, campo: String)
{
  return this.iface.saldoAcumulado;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
