//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_asientos.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var tdbPartidas: FLTableDB;
  var tbnPredefinido: Object;
  var usandoPredefinido: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function calculateField(fN: String)
  {
    return this.ctx.calculateField2(fN);
  }
  function calculaDescuadre()
  {
    this.ctx.calculaDescuadre3();
  }
  function tbnPredefinido_clicked()
  {
    this.ctx.tbnPredefinido_clicked4();
  }
  function mostrarDatosSubcuenta()
  {
    return this.ctx.mostrarDatosSubcuenta5();
  }
  function terminarPredefinido()
  {
    return this.ctx.terminarPredefinido6();
  }
  function mostrarConceptoAsiento()
  {
    return this.ctx.mostrarConceptoAsiento7();
  }
  function accionesCommitPartidas()
  {
    return this.ctx.accionesCommitPartidas8();
  }
  function validarPartidasAsiento()
  {
    return this.ctx.validarPartidasAsiento9();
  }
  function bufferChanged(fN: String)
  {
    return this.ctx.bufferChanged10(fN);
  }
  function pub_terminarPredefinido()
  {
    return this.terminarPredefinido();
  }
}
const iface = new interna(this);
/** \C Los nuevos asientos creados pertencen al ejercicio vigente en el momento de crearlos
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.mostrarDatosSubcuenta();
  this.iface.tdbPartidas = this.child("tdbPartidas");
  this.iface.tbnPredefinido = this.child("tbnPredefinido");
  this.iface.usandoPredefinido = false;
  connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
  connect(this.iface.tdbPartidas.cursor(), "newBuffer()", this, "iface.mostrarDatosSubcuenta");
  connect(this.iface.tdbPartidas.cursor(), "bufferCommited()", this, "iface.accionesCommitPartidas");
  connect(this.iface.tbnPredefinido, "clicked()", this, "iface.tbnPredefinido_clicked");
  if (cursor.modeAccess() == cursor.Insert) {
    cursor.setValueBuffer("codejercicio", flfactppal.iface.pub_ejercicioActual());
    this.child("fdbAsiento").setValue(flcontppal.iface.siguienteNumero(cursor.valueBuffer("codejercicio"), "nasiento"));
    var miVar = new FLVar();
    var tipoPredefinido = miVar.get("TIPOPRE");
    if (tipoPredefinido) {
      if (formco_asientos.iface.pub_pendientePre()) {
        formco_asientos.iface.pub_establecerPendientePre(false);
        var res = MessageBox.information(util.translate("scripts", "Siguiente asiento:\n%1").arg(util.sqlSelect("co_planasientos", "descripcion", "codplanasiento = '" + tipoPredefinido + "'")), MessageBox.Ok, MessageBox.Cancel);
        if (res == MessageBox.Ok) {
          this.child("fdbCodPlanAsiento").setValue(tipoPredefinido);
          this.iface.tbnPredefinido_clicked();
        }
      }
    }
  } else {
    this.iface.tbnPredefinido.enabled = false;
  }
  this.iface.calculaDescuadre();
}
/** \C El asiento deber presentar descuadre cero
\end */
function validateForm1()
{
  var util = new FLUtil;
  var cursor = this.cursor();
  cursor.setValueBuffer("importe", this.iface.calculateField("importe"));
  this.iface.calculaDescuadre();
  if (parseFloat(this.child("ledDescuadre").text) != 0) {
    MessageBox.warning(util.translate("scripts", "El descuadre del asiento debe ser cero"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  if (!flcontppal.iface.pub_comprobarAsiento(cursor.valueBuffer("idasiento"), true))
    return false;
  return true;
}
function calculateField2(fN)
{
  var util = new FLUtil();
  var result: String;
  var cursor = this.cursor();
  switch (fN) {
      /** \D Se calcula el descuadre del asiento: total del debe - total del haber en sus partidas
      \end */
    case "ledDescuadre": {
      var debe = util.sqlSelect("co_partidas", "SUM(debe)", "idasiento = " + cursor.valueBuffer("idasiento"));
      var haber = util.sqlSelect("co_partidas", "SUM(haber)", "idasiento = " + cursor.valueBuffer("idasiento"));
      var valorDescuadre = debe - haber;
      result = Math.round(valorDescuadre * 100) / 100
               result = util.roundFieldValue(result, "co_partidas", "debe");
      break;
    }
    case "importe": {
      result = util.sqlSelect("co_partidas", "SUM(debe)", "idasiento = " + cursor.valueBuffer("idasiento"));
      result = util.roundFieldValue(result, "co_asientos", "importe");
      break;
    }
  }
  return result;
}
/** \D Actualiza el valor de la etiqueta de descuadre
\end */
function calculaDescuadre3()
{
  var util = new FLUtil;
  this.child("ledDescuadre").text = this.iface.calculateField("ledDescuadre");
  if (this.iface.usandoPredefinido == "Terminado") {
    var siguientePlan = util.sqlSelect("co_planasientos", "concatenar", "codplanasiento = '" + this.cursor().valueBuffer("codplanasiento") + "'");
    if (siguientePlan && siguientePlan != "") {
      var miVar = new FLVar();
      if (!miVar.set("TIPOPRE", siguientePlan))
        return false;
      formco_asientos.iface.pub_establecerPendientePre(true);
      this.child("pushButtonAcceptContinue").animateClick();
    } else {
      flcontppal.iface.pub_clearPreMemoria();
    }
  }
}
/** \D Marca el asiento predefinido como Terminado. Sirve para que el formulario sepa que tiene que pasar al siguiente asiento.
\end */
function terminarPredefinido6()
{
  this.iface.usandoPredefinido = "Terminado";
}
/** \D Da a elegir al usuario entre una serie de opciones de partidas predefinidas
\end */
function tbnPredefinido_clicked4()
{
  var cursor = this.iface.tdbPartidas.cursor();
  var miVar = new FLVar();
  cursor.setAction("co_partidaspre");
  var tipoPredefinido = this.cursor().valueBuffer("codplanasiento");
  if (tipoPredefinido) {
    this.iface.usandoPredefinido = "En uso";
    if (!miVar.set("TIPOPRE", tipoPredefinido))
      return false;
    this.iface.tdbPartidas.cursor().insertRecord();
    //this.child("toolButtonInsertPar").animateClick();
  }
}
function mostrarDatosSubcuenta5()
{
  var util = new FLUtil();
  var cursor = this.child("tdbPartidas").cursor();
  if (!cursor.isValid()) {
    this.child("lblDatosSubcuenta").text = "";
    return;
  }
  var idSubcuenta = this.child("tdbPartidas").cursor().valueBuffer("idsubcuenta");
  var q = new FLSqlQuery();
  q.setTablesList("co_subcuentas");
  q.setSelect("codsubcuenta,descripcion,saldo");
  q.setFrom("co_subcuentas");
  q.setWhere("idsubcuenta = '" + idSubcuenta + "'");
  if (!q.exec())
    return false;
  if (!q.first())
    return false;
  var codsubcuenta = q.value(0);
  var descripcion = q.value(1);
  var saldo = util.roundFieldValue(q.value(2), "co_subcuentas", "saldo");
  this.child("lblDatosSubcuenta").text = codsubcuenta + " - " + descripcion;
  this.child("lblSaldoSubcuenta").text = saldo;
}
function accionesCommitPartidas8()
{
  this.iface.mostrarConceptoAsiento();
  var predefinido = this.cursor().valueBuffer("codplanasiento");
  if (predefinido && predefinido != "" && this.iface.usandoPredefinido == "Terminado") {
    if (this.iface.validarPartidasAsiento())
      this.iface.usandoPredefinido = false;
    this.iface.tdbPartidas.refresh();
  }
}
function validarPartidasAsiento9()
{
  var util: FLUtil;
  var idAsiento = this.cursor().valueBuffer("idasiento");
  var curPartidas = new FLSqlCursor("co_partidas");
  curPartidas.select("idasiento = " + idAsiento + " ORDER BY idpartida");
  var qPlantillas = new FLSqlQuery();
  qPlantillas.setTablesList("co_planpartidas");
  qPlantillas.setSelect("saltarsicero");
  qPlantillas.setFrom("co_planpartidas");
  qPlantillas.setWhere("codplanasiento = '" + this.cursor().valueBuffer("codplanasiento") + "' ORDER BY numorden");
  if (!qPlantillas.exec())
    return false;
  while (curPartidas.next() && qPlantillas.next()) {
    if (qPlantillas.value("saltarsicero") && curPartidas.valueBuffer("debe") == 0 && curPartidas.valueBuffer("haber") == 0) {
      curPartidas.setModeAccess(curPartidas.Del);
      curPartidas.refreshBuffer();
      if (!curPartidas.commitBuffer())
        return false;
    }
  }
  return true;
}
function mostrarConceptoAsiento7()
{
  var util = new FLUtil;
  var cursor = this.cursor();
  var conceptoAsiento = cursor.valueBuffer("concepto");
  if (!conceptoAsiento || conceptoAsiento == "") {
    if (this.child("tdbPartidas").cursor().isValid()) {
      var concepto = this.child("tdbPartidas").cursor().valueBuffer("concepto");
      cursor.setValueBuffer("concepto", concepto);
    }
  }
  var idConceptoAsiento = cursor.valueBuffer("idconcepto");
  if (!idConceptoAsiento || idConceptoAsiento == "") {
    if (this.child("tdbPartidas").cursor().isValid()) {
      var idConcepto = this.child("tdbPartidas").cursor().valueBuffer("idconcepto");
      cursor.setValueBuffer("idconcepto", idConcepto);
    }
  }
  var docAsiento = cursor.valueBuffer("documento");
  if (!docAsiento || docAsiento == "") {
    if (this.child("tdbPartidas").cursor().isValid()) {
      var documento = this.child("tdbPartidas").cursor().valueBuffer("documento");
      cursor.setValueBuffer("documento", documento);
    }
  }
  var tipoDocAsiento = cursor.valueBuffer("tipodocumento");
  if (!tipoDocAsiento || tipoDocAsiento == "") {
    if (this.child("tdbPartidas").cursor().isValid()) {
      var tipoDocumento = this.child("tdbPartidas").cursor().valueBuffer("tipodocumento");
      cursor.setValueBuffer("tipodocumento", tipoDocumento);
    }
  }
  this.iface.calculaDescuadre();
}
function bufferChanged10(fN: String)
{
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
