//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_epigrafes.qs  -  description
-------------------
begin                : lun jul 11 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var tbnBuscarEpigrafe: Object;
  var ejercicioActual: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function desconexion()
  {
    return this.ctx.desconexion2();
  }
  function tbnBuscarEpigrafe_clicked()
  {
    return this.ctx.tbnBuscarEpigrafe_clicked3();
  }
  function init()
  {
    this.ctx.init4();
  }
  function validateForm()
  {
    return this.ctx.validateForm5();
  }
}
const iface = new interna(this);
/** \C
En modo edicin los campos referentes al epgrafe padre del actual estarn inhabilitados
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.tbnBuscarEpigrafe = this.child("tbnBuscarEpigrafe");
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  switch (cursor.modeAccess()) {
    case cursor.Insert:
      cursor.setValueBuffer("codejercicio", this.iface.ejercicioActual);
      break;
    case cursor.Edit:
      this.iface.tbnBuscarEpigrafe.enabled = false;
      break;
  }
  connect(this.iface.tbnBuscarEpigrafe, "clicked()", this, "iface.tbnBuscarEpigrafe_clicked");
  connect(form, "closed()", this, "iface.desconexion");
}
function validateForm1()
{
  var cursor = this.cursor();
  var util = new FLUtil();
  /** \C El cdigo de epgrafe tendr como prefijo el cdigo del epgrafe padre
  \end */
  var codEpigrafePadre = this.child("fdbCodPadre").value();
  var codEpigrafe = cursor.valueBuffer("codepigrafe");
  if (codEpigrafePadre != codEpigrafe.substring(0, codEpigrafePadre.length)) {
    MessageBox.critical(util.translate("scripts",
                                       "El cdigo del epgrafe debe tener como prefijo el de su epgrafe padre"),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function desconexion2()
{
  disconnect(this.cursor(), "bufferChanged(QString)", this, "bufferChanged");
  disconnect(this.iface.tbnBuscarEpigrafe, "clicked()", this, "iface.tbnBuscarEpigrafe_clicked");
}
function tbnBuscarEpigrafe_clicked3()
{
  var cursor = this.cursor();
  var f = new FLFormSearchDB("co_epigrafes");
  f.setMainWidget();
  f.cursor().setMainFilter("codejercicio = '" + this.iface.ejercicioActual + "'");
  var idEpigrafe = f.exec("idepigrafe");
  if (idEpigrafe) {
    cursor.setValueBuffer("idpadre", idEpigrafe);
  }
}
function init4()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  switch (cursor.modeAccess()) {
    case cursor.Insert:
      cursor.setValueBuffer("codejercicio", this.iface.ejercicioActual);
      break;
  }
}
function validateForm5()
{
  return true;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
