//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_masterasientos.qs  -  description
-------------------
begin                : jue jul 22 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var pteAsientoPre: Boolean;
  var tdbRecords: FLTableDB;
  var ejercicioActual: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function pendientePre()
  {
    return this.ctx.pendientePre1();
  }
  function establecerPendientePre(pte: Boolean)
  {
    return this.ctx.establecerPendientePre2(pte);
  }
  function rellenarConceptos()
  {
    return this.ctx.rellenarConceptos3();
  }
  function init()
  {
    return this.ctx.init4();
  }
  function renumerarAsientos()
  {
    return this.ctx.renumerarAsientos5();
  }
  function pub_pendientePre()
  {
    return this.pendientePre();
  }
  function pub_establecerPendientePre(pte: Boolean)
  {
    return this.establecerPendientePre(pte);
  }
  function pub_renumerarAsientos()
  {
    return this.renumerarAsientos();
  }
}
const iface = new interna(this);
/** \C El formulario mostrar los asientos asociados al ejercicio actual
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.tdbRecords = this.child("tableDBRecords");
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  this.iface.pteAsientoPre = false;
  connect(this.child("pbnConceptos"), "clicked()", this, "iface.rellenarConceptos");
  cursor.setMainFilter("codEjercicio = '" + this.iface.ejercicioActual + "'");
  this.iface.tdbRecords.refresh();
}
function pendientePre1()
{
  return this.iface.pteAsientoPre;
}
function establecerPendientePre2(pte: Boolean)
{
  this.iface.pteAsientoPre = pte;
}
function rellenarConceptos3()
{
  var util = new FLUtil();
  var res = MessageBox.information(util.translate("scripts",  "A continuacin se rellenarn los conceptos vacos de los asientos de este ejercicio\nPara ello se copiar el concepto de la primera partida de cada asiento\n\nDesea continuar?"), MessageBox.Yes, MessageBox.No, MessageBox.NoButton);
  if (res != MessageBox.Yes)
    return;
  var codEjercicio = flfactppal.iface.pub_ejercicioActual();
  var curAsientos = new FLSqlCursor("co_asientos");
  curAsientos.setActivatedCommitActions(false);
  curAsientos.select("(concepto is NULL OR concepto = '' OR importe = 0) AND codejercicio = '" + codEjercicio + "'");
  var cursorBloqueado = new FLSqlCursor("co_asientos");
  var i = 0;
  util.createProgressDialog(util.translate("scripts", "Rellenando conceptos..."), curAsientos.size());
  util.setProgress(0);
  var idAsiento: Number, idPartida: Number;
  var datosPartida: Array;
  while (curAsientos.next()) {
    idAsiento = curAsientos.valueBuffer("idasiento");
    datosPartida = flfactppal.iface.pub_ejecutarQry("co_partidas", "concepto,idconcepto,documento,tipodocumento", "concepto IS NOT NULL AND idasiento = " + idAsiento + " order by documento");
    if (datosPartida.result < 1)
      continue;
    if (curAsientos.valueBuffer("editable") == true) {
      curAsientos.setModeAccess(curAsientos.Edit);
      curAsientos.refreshBuffer();
      curAsientos.setValueBuffer("concepto", datosPartida.concepto);
      curAsientos.setValueBuffer("idconcepto", datosPartida.idconcepto);
      curAsientos.setValueBuffer("documento", datosPartida.documento);
      curAsientos.setValueBuffer("tipodocumento", datosPartida.tipodocumento);
      if (!curAsientos.commitBuffer())
        return false;
      if (!flcontppal.iface.pub_comprobarAsiento(idAsiento))
        return false;
    } else {
      cursorBloqueado.setActivatedCommitActions(false);
      cursorBloqueado.select("idasiento = " + idAsiento);
      cursorBloqueado.first();
      cursorBloqueado.setUnLock("editable", true);
      cursorBloqueado.select("idasiento = " + idAsiento);
      cursorBloqueado.first();
      cursorBloqueado.setModeAccess(curAsientos.Edit);
      cursorBloqueado.refreshBuffer();
      cursorBloqueado.setValueBuffer("concepto", datosPartida.concepto);
      cursorBloqueado.setValueBuffer("idconcepto", datosPartida.idconcepto);
      cursorBloqueado.setValueBuffer("documento", datosPartida.documento);
      cursorBloqueado.setValueBuffer("tipodocumento", datosPartida.tipodocumento);
      if (!cursorBloqueado.commitBuffer())
        return false;
      if (!flcontppal.iface.pub_comprobarAsiento(idAsiento))
        return false;
      cursorBloqueado.select("idasiento = " + idAsiento);
      cursorBloqueado.first();
      cursorBloqueado.setUnLock("editable", false);
    }
    util.setProgress(i++);
  }
  util.destroyProgressDialog();
  this.iface.tdbRecords.refresh();
  MessageBox.information(util.translate("scripts",  "Proceso finalizado. Se actualizaron conceptos de %0 asientos").arg(curAsientos.size()), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
}
function init4()
{
  this.iface.__init();
  connect(this.child("pbnRenum"), "clicked()", this, "iface.renumerarAsientos()");
}
function renumerarAsientos5()
{
  var util = new FLUtil();
  var desEjercicio = util.sqlSelect("ejercicios", "nombre", "codejercicio = '" + this.iface.ejercicioActual + "'");
  var res = MessageBox.information(util.translate("scripts", "Se va a proceder a renumerar todos los asientos del diario correspondientes al ejercicio:\n%1 - %2.\n\nDesea continuar?").arg(this.iface.ejercicioActual).arg(desEjercicio), MessageBox.No, MessageBox.Yes);
  if (res != MessageBox.Yes)
    return;
  var codEjercicio = flfactppal.iface.pub_ejercicioActual();
  var numAsiento = 1;
  var rollback = false;
  var curAsientos = new FLSqlCursor("co_asientos");
  curAsientos.setActivatedCommitActions(false);
  curAsientos.select("codejercicio = '" + codEjercicio + "' order by fecha");
  var cursorBloqueado = new FLSqlCursor("co_asientos");
  var i = 0;
  util.createProgressDialog(util.translate("scripts", "Renumerando asientos..."), curAsientos.size());
  util.setProgress(0);
  var idAsiento: Number;
  curAsientos.transaction(false);
  while (curAsientos.next()) {
    idAsiento = curAsientos.valueBuffer("idasiento");
    if (curAsientos.valueBuffer("editable") == true) {
      curAsientos.setModeAccess(curAsientos.Edit);
      curAsientos.refreshBuffer();
      curAsientos.setValueBuffer("numero", numAsiento);
      if (!curAsientos.commitBuffer()) {
        debug("error en el asiento " + idAsiento);
        rollback = true;
        break;
      }
    } else {
      cursorBloqueado.setActivatedCommitActions(false);
      cursorBloqueado.select("idasiento = " + idAsiento);
      cursorBloqueado.first();
      cursorBloqueado.setUnLock("editable", true);
      cursorBloqueado.select("idasiento = " + idAsiento);
      cursorBloqueado.first();
      cursorBloqueado.setModeAccess(curAsientos.Edit);
      cursorBloqueado.refreshBuffer();
      cursorBloqueado.setValueBuffer("numero", numAsiento);
      if (!cursorBloqueado.commitBuffer()) {
        debug("error en el asiento bloq" + idAsiento);
        rollback = true;
        break;
      }
      cursorBloqueado.select("idasiento = " + idAsiento);
      cursorBloqueado.first();
      cursorBloqueado.setUnLock("editable", false);
    }
    numAsiento++;
    util.setProgress(i++);
  }
  var siguienteAsiento = numAsiento;
  if (!rollback) {
    if (util.sqlSelect("co_secuencias", "idsecuencia", "codejercicio = '" + this.iface.ejercicioActual + "' AND nombre = 'nasiento' AND valorout IS NOT NULL")) {
      if (!util.sqlUpdate("co_secuencias", "valorout", siguienteAsiento, "codejercicio = '" + this.iface.ejercicioActual + "' AND nombre = 'nasiento'"))
        rollback = true;
    } else {
      if (!util.sqlUpdate("co_secuencias", "valor", siguienteAsiento, "codejercicio = '" + this.iface.ejercicioActual + "' AND nombre = 'nasiento'"))
        rollback = true;
    }
  }
  if (rollback)
    curAsientos.rollback();
  else {
    curAsientos.commit();
  }
  util.destroyProgressDialog();
  this.iface.tdbRecords.refresh();
  var totalAsientos = util.sqlSelect("co_asientos", "COUNT(idasiento)", "codejercicio = '" + this.iface.ejercicioActual + "'");
  var ultimoAsiento = util.sqlSelect("co_asientos", "numero", "codejercicio = '" + this.iface.ejercicioActual + "' ORDER BY numero DESC");
  if (totalAsientos != ultimoAsiento) {
    MessageBox.warning(util.translate("scripts", "Ha habido un error en la renumeracin:\nEl total de asientos (%1) no coincide con el nmero del ltimo asiento (%2).\nVuelva a realizar la renumeracin.").arg(totalAsientos).arg(ultimoAsiento), MessageBox.Ok, MessageBox.NoButton);
    return;
  }
  var proxSecuencia: Number;
  if (util.sqlSelect("co_secuencias", "idsecuencia", "codejercicio = '" + this.iface.ejercicioActual + "' AND nombre = 'nasiento' AND valorout IS NOT NULL")) {
    proxSecuencia = util.sqlSelect("co_secuencias", "valorout", "codejercicio = '" + this.iface.ejercicioActual + "' AND nombre = 'nasiento'");
  } else {
    proxSecuencia = util.sqlSelect("co_secuencias", "valor", "codejercicio = '" + this.iface.ejercicioActual + "' AND nombre = 'nasiento'");
  }
  if (proxSecuencia != ++ultimoAsiento) {
    MessageBox.warning(util.translate("scripts", "Ha habido un error en la renumeracin:\nEl siguiente nmero de asiento en la secuencia (%1) no coincide con el nmero del ltimo asiento ms uno (%2).\nVuelva a realizar la renumeracin.").arg(proxSecuencia).arg(ultimoAsiento), MessageBox.Ok, MessageBox.NoButton);
    return;
  }
  MessageBox.information(util.translate("scripts", "Renumeracin completada correctamente."), MessageBox.Ok, MessageBox.NoButton);
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
