//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_masterregiva.qs  -  description
-------------------
begin                : lun jul 11 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var tdbRecords: FLTableDB;
  var toolButtonDelete: Object;
  var ejercicioActual: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function toolButtonDelete_clicked()
  {
    return this.ctx.toolButtonDelete_clicked1();
  }
  function editarAsiento()
  {
    return this.ctx.editarAsiento2();
  }
}
const iface = new interna(this);
function init0()
{
  var util = new FLUtil();
  var ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  this.iface.toolButtonDelete = this.child("toolButtonDelete");
  this.iface.tdbRecords = this.child("tableDBRecords");
  this.iface.tdbRecords.cursor().setMainFilter("codejercicio = '" + ejercicioActual + "'");
  this.iface.tdbRecords.setInsertOnly(true);
  this.iface.tdbRecords.refresh();
  connect(this.iface.toolButtonDelete, "clicked()", this, "iface.toolButtonDelete_clicked");
  connect(this.child("tbnEditarAsiento"), "clicked()", this, "iface.editarAsiento");
}
function toolButtonDelete_clicked1()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  var idregiva = cursor.valueBuffer("idregiva");
  if (!idregiva)
    return;
  var res = MessageBox.information(util.translate("scripts", "El registro activo y su asiento asociado sern borrados Est seguro?"), MessageBox.Yes, MessageBox.No, MessageBox.NoButton);
  if (res != MessageBox.Yes)
    return;
  util.sqlDelete("co_regiva", "idregiva = " + idregiva);
  this.iface.tdbRecords.refresh();
}
function editarAsiento2()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  if (!cursor.isValid()) {
    MessageBox.warning(util.translate("scripts", "No hay ningn registro seleccionado"), MessageBox.Ok, MessageBox.NoButton)
    return;
  }
  var res = MessageBox.information(util.translate("scripts", "Va a editar el asiento correspondiente a la regularizacin.\nEst seguro?"), MessageBox.Yes, MessageBox.No);
  if (res != MessageBox.Yes) {
    return false;
  }
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.select("idasiento = " + cursor.valueBuffer("idasiento"));
  curAsiento.first();
  if (!curAsiento.valueBuffer("editable")) {
    curAsiento.setUnLock("editable", true);
  }
  curAsiento.select("idasiento = " + cursor.valueBuffer("idasiento"));
  curAsiento.first();
  curAsiento.editRecord();
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
