//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_i_balancepyg.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function bufferChanged(fN: String)
  {
    return this.ctx.bufferChanged2(fN);
  }
  function unicoEjercicio()
  {
    return this.ctx.unicoEjercicio3();
  }
}
const iface = new interna(this);
/** \C
Si no existe otro ejercicio ms antiguo que el actual, los campos de ejercicio anterior aparecern deshabilitados. Si existe algn ejercicio previo al actual, aparecer como ejercicio anterior en el formulario aquel ejercicio ms reciente de entre los pasados.
\end */
function init0()
{
  var util = new FLUtil();
  this.child("fdbEjercicioAct").setDisabled(true);
  var cursor = this.cursor();
  var ejercicioActual: String;
  var ejercicioAnterior: String;
  if (cursor.modeAccess() == cursor.Insert) {
    ejercicioActual = flfactppal.iface.pub_ejercicioActual();
    var fechaInicioActual = util.sqlSelect("ejercicios", "fechainicio", "codejercicio = '" + ejercicioActual + "'");
    ejercicioAnterior = util.sqlSelect("ejercicios", "codejercicio", "fechafin < '" + fechaInicioActual + "' ORDER BY fechafin DESC");
    if (!ejercicioAnterior) {
      ejercicioAnterior = ejercicioActual;
      //this.iface.unicoEjercicio();
    }
    this.child("fdbEjercicioAct").setValue(ejercicioActual);
    this.child("fdbEjercicioAnt").setValue(ejercicioAnterior);
  } else {
    ejercicioActual = this.child("fdbEjercicioAct").value();
    ejercicioAnterior = this.child("fdbEjercicioAnt").value();;
    if (ejercicioActual == ejercicioAnterior) {
      this.iface.unicoEjercicio();
    }
  }
  connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
  this.child("fdbDescripcion").setFocus();
}
/** \C
La fecha de inicio del perodo de un ejercicio no puede ser posterior que la fecha de fin
Las fechas deben estar comprendidas dentro del perodo de cada ejercicio
Para poder realizar el balance sobre ms de un ejercicio es necesario que ambos tengan igual nmero de dgitos en las subcuentas
\end */
function validateForm1()
{
  var fechaDesde: String;
  var fechaHasta: String;
  var fechaInicio: String;
  var fechaFin: String;
  var fechaInicioAct: String;
  var fechaFinAnt: String;
  var util = new FLUtil();
  var q = new FLSqlQuery();
  var ejercicioAct = this.child("fdbEjercicioAct").value();
  fechaDesde = this.child("fdbFechaDesdeAct").value();
  fechaHasta = this.child("fdbFechaHastaAct").value();
  if (util.daysTo(fechaDesde, fechaHasta) < 0) {
    MessageBox.critical(util.translate("scripts", "La fecha de inicio del ejercicio actual debe ser menor que la de fin"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  q.setTablesList("ejercicios");
  q.setSelect("fechainicio, fechafin");
  q.setFrom("ejercicios");
  q.setWhere("codejercicio = '" + ejercicioAct + "';");
  q.exec();
  if (q.next()) {
    fechaInicio = q.value(0);
    fechaFin = q.value(1);
    fechaFinAnt = fechaFin;
  }
  if ((util.daysTo(fechaHasta, fechaFin) < 0) || (util.daysTo(fechaDesde, fechaInicio) > 0)) {
    MessageBox.critical(util.translate("scripts", "Las fechas de inicio y fin del ejercicio actual deben estar dentro del propio intervalo del ejercicio"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  if (!this.child("fdbEjercicioAnterior").value())
    return true;
  var ejercicioAnt = this.child("fdbEjercicioAnt").value();
  if (!flcontinfo.iface.pub_comprobarConsolidacion(ejercicioAct, ejercicioAnt)) {
    MessageBox.critical(util.translate("scripts", "Las subcuentas de los ejercicios deben tener la misma longitud"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  fechaDesde = this.child("fdbFechaDesdeAnt").value();
  fechaHasta = this.child("fdbFechaHastaAnt").value();
  if (util.daysTo(fechaDesde, fechaHasta) < 0) {
    MessageBox.critical(util.translate("scripts", "La fecha de inicio del ejercicio anterior debe ser menor que la de fin"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  q.setTablesList("ejercicios");
  q.setSelect("fechainicio, fechafin");
  q.setFrom("ejercicios");
  q.setWhere("codejercicio = '" + ejercicioAnt + "';");
  q.exec();
  if (q.next()) {
    fechaInicio = q.value(0);
    fechaFin = q.value(1);
    fechaFinAnt = fechaFin;
  }
  if ((util.daysTo(fechaHasta, fechaFin) < 0) || (util.daysTo(fechaDesde, fechaInicio) > 0)) {
    MessageBox.critical(util.translate("scripts", "Las fechas de inicio y fin del ejercicio anterior deben estar dentro del propio intervalo del ejercicio"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function bufferChanged2(fN: String)
{
  switch (fN) {
      /** \C
      Al pulsar sobre --ejercicioanterior-- se habilitan o deshabilitan los campos de ejercicio anterior
      \end */
    case "ejercicioanterior":
      if (this.child("fdbEjercicioAnterior").value()) {
        this.child("gbEjAnt").setDisabled(false);
        this.child("fdbConsolidar").setDisabled(false);
      } else {
        this.child("gbEjAnt").setDisabled(true);
        this.child("fdbConsolidar").setValue(false);
        this.child("fdbConsolidar").setDisabled(true);
      }
      break;
  }
}
/** \D Se ejecuta cuando slo hay un ejercicio factible de aparecen en el formulario, esto es, cuando no hay ningn ejercicio anterior al actual. Se encarga de deshabilitar los campos de ejercicio anterior
\end */
function unicoEjercicio3()
{
  /*
  this.child("gbEjAnt").setDisabled(true);
  this.child("fdbEjercicioAnterior").setDisabled(true);
  this.child("fdbEjercicioAnterior").setValue(false);
  this.child("fdbConsolidar").setDisabled(true);
  */
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
