//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_i_balancesis.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var ejercicioActual: String;
  var ejercicioAnterior: String;
  var longSubcuenta: Number;
  var bloqueoSubcuenta: Boolean;
  var cuentaHastaInformada: Boolean
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function bufferChanged(fN: String)
  {
    return this.ctx.bufferChanged2(fN);
  }
  function deshabilitarSubcuentas(valor_disabled: Boolean)
  {
    return this.ctx.deshabilitarSubcuentas3(valor_disabled);
  }
  function todasSubcuentas()
  {
    return this.ctx.todasSubcuentas4();
  }
  function init()
  {
    this.ctx.init5();
  }
  function bufferChanged(fN)
  {
    return this.ctx.bufferChanged6(fN);
  }
  function controlConsolidacion()
  {
    return this.ctx.controlConsolidacion7();
  }
}
const iface = new interna(this);
/** \C
Si no existe otro ejercicio ms antiguo que el actual, los campos de ejercicio anterior aparecern deshabilitados. Si existe algn ejercicio previo al actual, aparecer como ejercicio anterior en el formulario aquel ejercicio ms reciente de entre los pasados.
En modo insercin aparece seleccionada la opcion --todassubcuentas--, y aparece como subcuenta inicial la de menor cdigo y como subcuenta final la de mayor cdigo
\end */
function init0()
{
  this.iface.cuentaHastaInformada = false;
  var util = new FLUtil();
  var cursor = this.cursor();
  if (cursor.modeAccess() == cursor.Insert)
    this.iface.todasSubcuentas();
  this.iface.longSubcuenta = util.sqlSelect("ejercicios", "longsubcuenta", "codejercicio = '" + this.iface.ejercicioActual + "'");
  if (cursor.modeAccess() == cursor.Edit) {
    if (this.child("fdbTodasSubcuentas").value())
      this.iface.todasSubcuentas();
  }
  connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
  this.child("fdbDescripcion").setFocus();
}
/** \C
La fecha de inicio del perodo de un ejercicio no puede ser posterior que la fecha de fin
Las fechas deben estar comprendidas dentro del perodo de cada ejercicio
Para poder realizar el balance sobre ms de un ejercicio es necesario que ambos tengan igual nmero de dgitos en las subcuentas
\end */
function validateForm1()
{
  var fechaDesde: String;
  var fechaHasta: String;
  var fechaInicio: String;
  var fechaFin: String;
  var fechaInicioAct: String;
  var fechaFinAnt: String;
  var util = new FLUtil();
  var q = new FLSqlQuery();
  var ejercicioAct = this.child("fdbEjercicioAct").value();
  fechaDesde = this.child("fdbFechaDesdeAct").value();
  fechaHasta = this.child("fdbFechaHastaAct").value();
  if (util.daysTo(fechaDesde, fechaHasta) < 0) {
    MessageBox.critical(util.translate("scripts", "La fecha de inicio del ejercicio actual debe ser menor que la de fin"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  q.setTablesList("ejercicios");
  q.setSelect("fechainicio, fechafin");
  q.setFrom("ejercicios");
  q.setWhere("codejercicio = '" + ejercicioAct + "';");
  q.exec();
  if (q.next()) {
    fechaInicio = q.value(0);
    fechaFin = q.value(1);
    fechaFinAnt = fechaFin;
  }
  if ((util.daysTo(fechaHasta, fechaFin) < 0) || (util.daysTo(fechaDesde, fechaInicio) > 0)) {
    MessageBox.critical(util.translate("scripts", "Las fechas de inicio y fin del ejercicio actual deben estar dentro del propio intervalo del ejercicio"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  if (!this.child("fdbEjercicioAnterior").value())
    return true;
  var ejercicioAnt = this.child("fdbEjercicioAnt").value();
  if (!flcontinfo.iface.pub_comprobarConsolidacion(ejercicioAct, ejercicioAnt)) {
    MessageBox.critical(util.translate("scripts", "Las subcuentas de los ejercicios deben tener la misma longitud"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  fechaDesde = this.child("fdbFechaDesdeAnt").value();
  fechaHasta = this.child("fdbFechaHastaAnt").value();
  if (util.daysTo(fechaDesde, fechaHasta) < 0) {
    MessageBox.critical(util.translate("scripts", "La fecha de inicio del ejercicio anterior debe ser menor que la de fin"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  q.setTablesList("ejercicios");
  q.setSelect("fechainicio, fechafin");
  q.setFrom("ejercicios");
  q.setWhere("codejercicio = '" + ejercicioAnt + "';");
  q.exec();
  if (q.next()) {
    fechaInicio = q.value(0);
    fechaInicio = fechaInicio.toString();
    fechaFin = q.value(1);
    fechaFin = fechaFin.toString();
    fechaFinAnt = fechaFin;
  }
  if ((util.daysTo(fechaHasta, fechaFin) < 0) || (util.daysTo(fechaDesde, fechaInicio) > 0)) {
    MessageBox.critical(util.translate("scripts", "Las fechas de inicio y fin del ejercicio anterior deben estar dentro del propio intervalo del ejercicio"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function bufferChanged2(fN: String)
{
  var codSubcuenta: String;
  switch (fN) {
      /** \C
      Al introducir --d_co__subcuentas_codsubcuenta--, si el usuario pulsa la tecla "punto" (.), la subcuenta se informa automaticamente con el cdigo de cuenta ms tantos ceros como sea necesario para completar la longitud de subcuenta asociada al ejercicio actual.
      \end \end */
    case "d_co__subcuentas_codsubcuenta":
      if (!this.iface.bloqueoSubcuenta
          && this.child("fdbCodSubcuentaDesde").value().endsWith(".")) {
        codSubcuenta =
          this.child("fdbCodSubcuentaDesde").value().toString();
        codSubcuenta = codSubcuenta.substring(0, codSubcuenta.length - 1);
        var numCeros = this.iface.longSubcuenta - codSubcuenta.length;
        for (var i = 0; i < numCeros; i++)
          codSubcuenta += "0";
        this.iface.bloqueoSubcuenta = true;
        this.child("fdbCodSubcuentaDesde").setValue(codSubcuenta);
        if (!this.iface.cuentaHastaInformada) {
          this.child("fdbCodSubcuentaHasta").setValue(codSubcuenta);
        }
        this.iface.bloqueoSubcuenta = false;
      }
      if (!this.iface.bloqueoSubcuenta
          && this.child("fdbCodSubcuentaDesde").value().length ==
          this.iface.longSubcuenta) {
        if (!this.iface.cuentaHastaInformada) {
          this.child("fdbCodSubcuentaHasta").setValue(codSubcuenta);
        }
      }
      break;
      /** \C
      Al introducir --h_co__subcuentas_codsubcuenta--, si el usuario pulsa la tecla "punto" (.), la subcuenta se informa automaticamente con el cdigo de cuenta ms tantos ceros como sea necesario para completar la longitud de subcuenta asociada al ejercicio actual.
      \end */
    case "h_co__subcuentas_codsubcuenta":
      this.iface.cuentaHastaInformada = true;
      if (!this.iface.bloqueoSubcuenta
          && this.child("fdbCodSubcuentaHasta").value().endsWith(".")) {
        codSubcuenta =
          this.child("fdbCodSubcuentaHasta").value().toString();
        codSubcuenta = codSubcuenta.substring(0, codSubcuenta.length - 1);
        var numCeros = this.iface.longSubcuenta - codSubcuenta.length;
        for (var i = 0; i < numCeros; i++)
          codSubcuenta += "0";
        this.iface.bloqueoSubcuenta = true;
        this.child("fdbCodSubcuentaHasta").setValue(codSubcuenta);
        this.iface.bloqueoSubcuenta = false;
      }
      if (!this.iface.bloqueoSubcuenta
          && this.child("fdbCodSubcuentaHasta").value().length ==
          this.iface.longSubcuenta) {
      }
      break;
      /** \C
      Al pulsar sobre --todassubcuentas-- aparece como subcuenta inicial la de menor cdigo y como subcuenta final la de mayor cdigo
      \end */
    case "todassubcuentas":
      if (this.child("fdbTodasSubcuentas").value())
        this.iface.todasSubcuentas();
      else {
        this.iface.bloqueoSubcuenta = true;
        this.child("fdbCodSubcuentaDesde").setValue("");
        this.child("fdbCodSubcuentaHasta").setValue("");
        this.iface.bloqueoSubcuenta = false;
        this.iface.cuentaHastaInformada = false;
        this.iface.deshabilitarSubcuentas(false);
      }
      break;
  }
}
/** \D Se deshabilitan o habilitan los campos de subcuenta
@param valor_disabled Valor booleano que indica si se deshabilita o habilita
\end */
function deshabilitarSubcuentas3(valor_disabled: Boolean)
{
  this.child("fdbCodSubcuentaDesde").setDisabled(valor_disabled);
  this.child("fdbIdSubcuentaDesde").setDisabled(valor_disabled);
  this.child("fdbCodSubcuentaHasta").setDisabled(valor_disabled);
  this.child("fdbIdSubcuentaHasta").setDisabled(valor_disabled);
}
/** \D Se buscan los cdigos de subcuenta mayor y menor dentro de la tabla de subcuentas. Se llama cuando se pulsa --todassubcuentas--
\end */
function todasSubcuentas4()
{
  var codEjercicioAct = this.child("fdbEjercicioAct").value();
  var codEjercicioAnt = this.child("fdbEjercicioAnt").value();
  var q = new FLSqlQuery();
  q.setTablesList("co_subcuentas");
  q.setSelect("MIN(codsubcuenta), MAX(codsubcuenta)");
  q.setFrom("co_subcuentas");
  q.setWhere("codejercicio = '" + codEjercicioAct +
             "' OR codejercicio = '" + codEjercicioAnt + "'");
  q.exec();
  if (q.first()) {
    var subcuentaInicio = q.value(0);
    var subcuentaFin = q.value(1);
    this.iface.bloqueoSubcuenta = true;
    this.child("fdbCodSubcuentaDesde").setValue(subcuentaInicio);
    this.child("fdbCodSubcuentaHasta").setValue(subcuentaFin);
    this.iface.deshabilitarSubcuentas(true);
    this.iface.bloqueoSubcuenta = false;
  }
}
function init5()
{
  this.iface.__init();
  this.iface.controlConsolidacion()
}
function bufferChanged6(fN)
{
  var util = new FLUtil();
  switch (fN) {
    case "ejercicioanterior":
      this.iface.controlConsolidacion();
      break;
    default:
      return this.iface.__bufferChanged(fN);
  }
}
function controlConsolidacion7()
{
  if (this.cursor().valueBuffer("ejercicioanterior"))  {
    this.child("tbwEmpresas").setTabEnabled("tbwotras", false);
    this.child("fdbEjercicioAnt").setDisabled(false);
    this.child("fdbFechaDesdeAnt").setDisabled(false);
    this.child("fdbFechaHastaAnt").setDisabled(false);
  } else {
    this.child("tbwEmpresas").setTabEnabled("tbwotras", true);
    this.child("fdbEjercicioAnt").setDisabled(true);
    this.child("fdbFechaDesdeAnt").setDisabled(true);
    this.child("fdbFechaHastaAnt").setDisabled(true);
  }
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
