//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_i_facturasemi.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var ejercicioActual: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function bufferChanged(fN: String)
  {
    return this.ctx.bufferChanged2(fN);
  }
}
const iface = new interna(this);
/** \C
En modo insercin aparece seleccionado el ejercicio actual
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
  if (cursor.modeAccess() == cursor.Insert) {
    this.child("fdbEjercicio").setValue(this.iface.ejercicioActual);
  }
}
/** \C
La fecha de inicio no puede ser posterior a la de fin
\end */
function validateForm1()
{
  var fechaInicio = this.child("fdbFechaDesde").value();
  var fechaFin = this.child("fdbFechaHasta").value();
  var util = new FLUtil();
  if (util.daysTo(fechaInicio, fechaFin) < 0) {
    MessageBox.critical
    (util.
     translate("scripts",
               "La fecha de inicio debe ser menor que la de fin"),
     MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function bufferChanged2(fN: String)
{
  switch (fN) {
    case "todosivarecargo":
      if (this.child("fdbTodosIvaRecargo").value()) {
        this.child("fdbIva").setValue(0);
        this.child("fdbRecargo").setValue(0);
        this.child("fdbIva").setDisabled(true);
        this.child("fdbRecargo").setDisabled(true);
      } else {
        this.child("fdbIva").setDisabled(false);
        this.child("fdbRecargo").setDisabled(false);
      }
  }
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
