//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
empresa.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var pbnCambiarEjercicioActual: Object;
  function interna(context)
  {
    this.ctx = context;
  }
  function main()
  {
    this.ctx.main0();
  }
  function init()
  {
    this.ctx.init1();
  }
  function pbnCambiarEjercicioActual_clicked()
  {
    return this.ctx.pbnCambiarEjercicioActual_clicked2();
  }
  function mostrarEjercicioActual()
  {
    return this.ctx.mostrarEjercicioActual3();
  }
}
const iface = new interna(this);
/** \C Cuando cambia el ejercicio actual se establece el ttulo de las ventanas principales con
el nombre del ejercicio seleccionado
\end */
function init1()
{
  this.iface.pbnCambiarEjercicioActual = this.child("pbnCambiarEjercicioActual");
  connect(this.iface.pbnCambiarEjercicioActual, "clicked()", this, "iface.pbnCambiarEjercicioActual_clicked");
  this.iface.mostrarEjercicioActual();
}
/** \C Se abre un dilogo que permite seleccionar un ejercicio entre los existentes, o bien crear un nuevo ejercicio
\end */
function main0()
{
  var f = new FLFormSearchDB("co_cambiarejer");
  var cursor = f.cursor();
  cursor.select();
  if (!cursor.first())
    return false;
  else
    cursor.setModeAccess(cursor.Edit);
  f.setMainWidget();
  cursor.refreshBuffer();
  var commitOk = false;
  var acpt: Boolean;
  cursor.transaction(false);
  while (!commitOk) {
    acpt = false;
    f.exec("codejercicio");
    acpt = f.accepted();
    if (!acpt) {
      if (cursor.rollback())
        commitOk = true;
    } else {
      if (cursor.commitBuffer()) {
        cursor.commit();
        commitOk = true;
      }
    }
    f.close();
  }
}
/** \D Cambia el ejercicio actual para el usuario conectado
*/
function pbnCambiarEjercicioActual_clicked2()
{
  if (!formempresa.iface.pub_cambiarEjercicioActual())
    return;
  this.iface.mostrarEjercicioActual();
}
/** \D Muestra el ejercicio actual en el formulario y en el Main Widget
*/
function mostrarEjercicioActual3()
{
  var util = new FLUtil();
  var codEjercicio = flfactppal.iface.pub_ejercicioActual();
  var nombreEjercicio = util.sqlSelect("ejercicios", "nombre", "codejercicio='" + codEjercicio + "'");
  try {
    sys.setCaptionMainWidget(nombreEjercicio);
    this.child("lblValEjercicioActual").text = codEjercicio + " - " + nombreEjercicio;
    this.child("lblEjercicioActual").text = util.translate("scripts", "Ejercicio actual para ") + sys.nameUser() + ":";
  } catch (e) {}
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
