//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_cerrarejer.qs  -  description
-------------------
begin                : mar ago 10 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var divisaEmpresa: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function tbnCerrar_clicked()
  {
    return this.ctx.tbnCerrar_clicked1();
  }
  function asientoPyG()
  {
    return this.ctx.asientoPyG2();
  }
  function asientoCierre()
  {
    return this.ctx.asientoCierre3();
  }
  function asientoApertura(idAsientoCierre, ejNuevo)
  {
    return this.ctx.asientoApertura4(idAsientoCierre, ejNuevo);
  }
  function tbnEjercicio_clicked()
  {
    return this.ctx.tbnEjercicio_clicked5();
  }
  function validarCierre()
  {
    return this.ctx.validarCierre6();
  }
  function rollbackCierre()
  {
    return this.ctx.rollbackCierre7();
  }
  function comprobarSaldos()
  {
    return this.ctx.comprobarSaldos8();
  }
  function crearSubcuentaApertura(codSubcuenta: String, ejNuevo: String)
  {
    return this.ctx.crearSubcuentaApertura9(codSubcuenta, ejNuevo);
  }
  function comprobarPartidasHuerfanas()
  {
    return this.ctx.comprobarPartidasHuerfanas10();
  }
  function validarCierre()
  {
    return this.ctx.validarCierre11();
  }
  function asientoApertura(idAsientoCierre, ejNuevo)
  {
    return this.ctx.asientoApertura12(idAsientoCierre, ejNuevo);
  }
  function comprobarSaldosHuerfanos()
  {
    return this.ctx.comprobarSaldosHuerfanos13();
  }
  function asientoCierre()
  {
    return this.ctx.asientoCierre14();
  }
  function asientoPyG()
  {
    return this.ctx.asientoPyG15();
  }
  function comprobarSubcuentas08(idAsientoCierre: Number, ejNuevo: String)
  {
    return this.ctx.comprobarSubcuentas0816(idAsientoCierre, ejNuevo);
  }
  function pub_asientoApertura(idAsientoCierre, ejNuevo)
  {
    return this.asientoApertura(idAsientoCierre, ejNuevo);
  }
}
const iface = new interna(this);
/** \C Para cerrar el ejercicio, el usuario podr decidir cules de las siguientes operaciones se realizarn automticamente:
Contabilizar las diferencias de cambio: Crear asientos correspondientes a recibos sin pagar en moneda extranjera, de forma que se establezca el valor de la deuda a fecha de cierre del ejercicio.
Realizar el asiento de regularizacin en la cuenta de prdidas y ganancias
Realizar el asiento de cierre de ejercicio
Realizar el asiento de apertura de ejercicio siguiente. Para poder generar el asiento de apertura, el ejercicio seleccionado debe tener generado su correspondiente plan general contable. Si se selecciona el check de generar asiento de apertura, se tendr que seleccionar un ejercicio abierto que no contenga ya un asiento de apertura
\end */
function init0()
{
  var util = new FLUtil;
  var cursor = this.cursor();
  this.child("pushButtonAccept").enabled = false;
  //var hoy= new Date();
  this.child("dedFecha").date = cursor.valueBuffer("fechafin");
  this.iface.divisaEmpresa = util.sqlSelect("empresa", "coddivisa", "1 = 1");
  /** \U
  Botn de cierre de ejercicio link_tbnCerrar_clicked
  Botn de seleccion de ejercicio de apertura link_tbnEjercicio_clicked
  \end */
  connect(this.child("tbnCerrar"), "clicked()", this, "iface.tbnCerrar_clicked()");
  connect(this.child("tbnEjercicio"), "clicked()", this, "iface.tbnEjercicio_clicked()");
}
/** \C
Arranca el cierre del ejercicio ejecutando todas las opciones seleccionadas
\end */
function tbnCerrar_clicked1()
{
  var util = new FLUtil();
  if (!this.iface.validarCierre())
    return false;
  if (!this.iface.comprobarSaldos())
    return false;
  if (this.child("ckbPyG").checked == true)
    if (!this.iface.asientoPyG()) {
      MessageBox.critical(util.translate("scripts",
                                         "Error al generar el asiento de regularizacin de prdidas y ganancias"),
                          MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
      this.iface.rollbackCierre()
      return false;
    }
  if (this.child("ckbAsientoCierre").checked == true)
    if (!this.iface.asientoCierre()) {
      MessageBox.critical(util.translate("scripts",
                                         "Error al generar el asiento de cierre"),
                          MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
      this.iface.rollbackCierre()
      return false;
    }
  if (this.child("ckbAsientoApertura").checked == true) {
    if (!this.iface.asientoApertura(this.cursor().valueBuffer("idasientocierre"), this.child("ledEjercicio").text)) {
      MessageBox.critical(util.translate("scripts",
                                         "Error al generar el asiento de apertura"),
                          MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
      this.iface.rollbackCierre()
      return false;
    }
  }
  this.child("pushButtonAccept").enabled = true;
  this.child("pushButtonAccept").animateClick();
  return true;
}
/** \D
Genera el asiento de prdidas y ganancias buscando las cuentas cuyo cdigo de balance tenga como naturaleza DEBE o HABER
@return true en caso de xito, false en caso contrario
\end */
function asientoPyG2()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  var qryPyG = new FLSqlQuery();
  qryPyG.setForwardOnly(true);
  qryPyG.setTablesList("co_cuentas,co_subcuentas,co_codbalances");
  qryPyG.setSelect("s.saldo, s.idsubcuenta, s.codsubcuenta");
  qryPyG.setFrom("co_cuentas c INNER JOIN co_subcuentas s ON c.idcuenta = s.idcuenta" +
                 " INNER JOIN co_codbalances b ON c.codbalance = b.codbalance");
  qryPyG.setWhere("c.codejercicio = '" + cursor.valueBuffer("codejercicio") + "'" +
                  " AND s.saldo <> 0" +
                  " AND b.naturaleza IN ('DEBE', 'HABER')");
  if (!qryPyG.exec())
    return false;
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.setForwardOnly(true);
  curAsiento.setModeAccess(curAsiento.Insert);
  curAsiento.refreshBuffer();
  curAsiento.setValueBuffer("numero", 0);
  curAsiento.setValueBuffer("fecha", this.child("dedFecha").date);
  curAsiento.setValueBuffer("codejercicio", cursor.valueBuffer("codejercicio"));
  if (!curAsiento.commitBuffer())
    return false;
  util.createProgressDialog(util.translate("scripts", "Creando asiento de regularizacin..."), qryPyG.size());
  util.setProgress(1);
  var idAsiento = curAsiento.valueBuffer("idasiento");
  var curPartida = new FLSqlCursor("co_partidas");
  curPartida.setForwardOnly(true);
  var debe = 0;
  var haber = 0;
  var totalDebe = 0;
  var totalHaber = 0;
  var paso = 0;
  while (qryPyG.next()) {
    if (parseFloat(qryPyG.value(0)) > 0) {
      debe = 0;
      haber = parseFloat(qryPyG.value(0));
    } else {
      debe = 0 - parseFloat(qryPyG.value(0));
      haber = 0;
    }
    totalDebe += debe;
    totalHaber += haber;
    curPartida.setModeAccess(curPartida.Insert);
    curPartida.refreshBuffer();
    curPartida.setValueBuffer("concepto", util.translate("scripts", "Regularizacin ejercicio ") +
                              cursor.valueBuffer("nombre"));
    curPartida.setValueBuffer("idsubcuenta", qryPyG.value(1));
    curPartida.setValueBuffer("codsubcuenta", qryPyG.value(2));
    curPartida.setValueBuffer("idasiento", idAsiento);
    curPartida.setValueBuffer("debe", debe);
    curPartida.setValueBuffer("haber", haber);
    curPartida.setValueBuffer("coddivisa", this.iface.divisaEmpresa);
    curPartida.setValueBuffer("tasaconv", 1);
    curPartida.setValueBuffer("debeME", 0);
    curPartida.setValueBuffer("haberME", 0);
    util.setProgress(paso++);
    if (!curPartida.commitBuffer()) {
      util.destroyProgressDialog();
      return false;
    }
  }
  var ctaPyG = flfactppal.iface.pub_ejecutarQry("co_cuentas c INNER JOIN co_subcuentas s" +
                                                " ON c.idcuenta = s.idcuenta", "idsubcuenta,codsubcuenta",
                                                "c.idcuentaesp = 'PYG' AND c.codejercicio = '" + cursor.valueBuffer("codejercicio") + "'",
                                                "co_cuentas,co_subcuentas");
  if (ctaPyG.result != 1) {
    util.destroyProgressDialog();
    MessageBox.warning(util.translate("scripts",
                                      "Error en la bsqueda de la cuenta de prdidas y ganancias"),
                       MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  if (totalDebe > totalHaber) {
    debe = 0;
    haber = totalDebe - totalHaber;
  } else {
    debe = totalHaber - totalDebe;
    haber = 0;
  }
  curPartida.setModeAccess(curPartida.Insert);
  curPartida.refreshBuffer();
  curPartida.setValueBuffer("concepto", util.translate("scripts", "Regularizacin ejercicio ") + cursor.valueBuffer("nombre"));
  curPartida.setValueBuffer("idsubcuenta", ctaPyG.idsubcuenta);
  curPartida.setValueBuffer("codsubcuenta", ctaPyG.codsubcuenta);
  curPartida.setValueBuffer("idasiento", idAsiento);
  curPartida.setValueBuffer("debe", debe);
  curPartida.setValueBuffer("haber", haber);
  curPartida.setValueBuffer("coddivisa", this.iface.divisaEmpresa);
  curPartida.setValueBuffer("tasaconv", 1);
  curPartida.setValueBuffer("debeME", 0);
  curPartida.setValueBuffer("haberME", 0);
  if (!curPartida.commitBuffer()) {
    util.destroyProgressDialog();
    return false;
  }
  curAsiento.select("idasiento = " + idAsiento);
  curAsiento.first();
  curAsiento.setModeAccess(curAsiento.Edit);
  curAsiento.refreshBuffer();
  curAsiento.setUnLock("editable", false);
  cursor.setValueBuffer("idasientopyg", idAsiento);
  util.destroyProgressDialog();
  return true;
}
/** \D
Genera el asiento de cierre buscando las cuentas cuyo cdigo de balance tenga como naturaleza ACTIVO o PASIVO
@return true en caso de xito, false en caso contrario
\end */
function asientoCierre3()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  var qryAsientoCierre = new FLSqlQuery();
  qryAsientoCierre.setForwardOnly(true);
  qryAsientoCierre.setTablesList("co_cuentas,co_subcuentas,co_codbalances");
  qryAsientoCierre.setSelect("s.saldo, s.idsubcuenta, s.codsubcuenta");
  qryAsientoCierre.setFrom("co_cuentas c INNER JOIN co_subcuentas s ON c.idcuenta = s.idcuenta" +
                           " INNER JOIN co_codbalances b ON c.codbalance = b.codbalance");
  qryAsientoCierre.setWhere("c.codejercicio = '" + cursor.valueBuffer("codejercicio") + "'" +
                            " AND s.saldo <> 0" +
                            " AND b.naturaleza IN ('ACTIVO', 'PASIVO')");
  if (!qryAsientoCierre.exec())
    return false;
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.setForwardOnly(true);
  curAsiento.setModeAccess(curAsiento.Insert);
  curAsiento.refreshBuffer();
  curAsiento.setValueBuffer("numero", 0);
  curAsiento.setValueBuffer("fecha", this.child("dedFecha").date);
  curAsiento.setValueBuffer("codejercicio", cursor.valueBuffer("codejercicio"));
  if (!curAsiento.commitBuffer())
    return false;
  util.createProgressDialog(util.translate("scripts", "Creando asiento de cierre..."), qryAsientoCierre.size());
  util.setProgress(1);
  var idAsiento = curAsiento.valueBuffer("idasiento");
  var curPartida = new FLSqlCursor("co_partidas");
  curPartida.setForwardOnly(true);
  var debe = 0;
  var haber = 0;
  var totalDebe = 0;
  var totalHaber = 0;
  var paso = 0;
  while (qryAsientoCierre.next()) {
    if (parseFloat(qryAsientoCierre.value(0)) > 0) {
      debe = 0;
      haber = parseFloat(qryAsientoCierre.value(0));
    } else {
      debe = 0 - parseFloat(qryAsientoCierre.value(0));
      haber = 0;
    }
    totalDebe += debe;
    totalHaber += haber;
    curPartida.setModeAccess(curPartida.Insert);
    curPartida.refreshBuffer();
    curPartida.setValueBuffer("concepto", util.translate("scripts", "Asiento de cierre de ejercicio ") +
                              cursor.valueBuffer("nombre"));
    curPartida.setValueBuffer("idsubcuenta", qryAsientoCierre.value(1));
    curPartida.setValueBuffer("codsubcuenta", qryAsientoCierre.value(2));
    curPartida.setValueBuffer("idasiento", idAsiento);
    curPartida.setValueBuffer("debe", debe);
    curPartida.setValueBuffer("haber", haber);
    curPartida.setValueBuffer("coddivisa", this.iface.divisaEmpresa);
    curPartida.setValueBuffer("tasaconv", 1);
    curPartida.setValueBuffer("debeME", 0);
    curPartida.setValueBuffer("haberME", 0);
    util.setProgress(paso++);
    if (!curPartida.commitBuffer()) {
      util.destroyProgressDialog();
      return false;
    }
  }
  if (Math.round(parseFloat(totalDebe)) != Math.round(parseFloat(totalHaber))) {
    MessageBox.critical(util.translate("scripts",
                                       "Asiento de cierre: los totales de debe y haber no coinciden\n" +
                                       "DEBE : " + Math.round(parseFloat(totalDebe)) + "  HABER : " + Math.round(parseFloat(totalHaber))),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    util.destroyProgressDialog();
    return false;
  }
  curAsiento.select("idasiento = " + idAsiento);
  curAsiento.first();
  curAsiento.setModeAccess(curAsiento.Edit);
  curAsiento.refreshBuffer();
  curAsiento.setUnLock("editable", false);
  cursor.setValueBuffer("idasientocierre", idAsiento);
  util.destroyProgressDialog();
  return true;
}
/** \D
Genera el asiento de apertura del nuevo ejercicio
@param  idAsientoCierre ID del asiento de cierre del ejercicio antiguo
@param  ejNuevo Cdigo del nuevo ejercicio
@return true en caso de xito, false en caso contrario
\end */
function asientoApertura4(idAsientoCierre, ejNuevo)
{
  var util = new FLUtil();
  if (ejNuevo == "")
    return false;
  if (!util.sqlSelect("co_subcuentas", "idsubcuenta", "codejercicio = '" + ejNuevo + "'"))
    return false;
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.setForwardOnly(true);
  var fechaAsiento = util.sqlSelect("ejercicios", "fechainicio", "codejercicio = '" + ejNuevo + "'");
  var nombreEjercicio = util.sqlSelect("ejercicios", "nombre", "codejercicio = '" + ejNuevo + "'");
  curAsiento.setModeAccess(curAsiento.Insert);
  curAsiento.refreshBuffer();
  curAsiento.setValueBuffer("numero", 0);
  curAsiento.setValueBuffer("fecha", fechaAsiento);
  curAsiento.setValueBuffer("codejercicio", ejNuevo);
  if (!curAsiento.commitBuffer())
    return false;
  var idAsiento = curAsiento.valueBuffer("idasiento");
  var qryCierre = new FLSqlQuery();
  qryCierre.setForwardOnly(true);
  with(qryCierre) {
    setTablesList("co_partidas");
    setSelect("codsubcuenta, debe, haber, coddivisa, tasaconv, debeME, haberME");
    setFrom("co_partidas");
    setWhere("idasiento = " + idAsientoCierre);
  }
  if (!qryCierre.exec())
    return false;
  util.createProgressDialog(util.translate("scripts", "Creando asiento de apertura..."), qryCierre.size());
  util.setProgress(1);
  var curApertura = new FLSqlCursor("co_partidas");
  curApertura.setForwardOnly(true);
  var paso = 0;
  var idSubcuentaAp: String;
  while (qryCierre.next()) {
    idSubcuentaAp = util.sqlSelect("co_subcuentas", "idsubcuenta", "codsubcuenta = '" + qryCierre.value("codsubcuenta") + "' AND codejercicio = '" + ejNuevo + "'");
    if (!idSubcuentaAp) {
      util.destroyProgressDialog();
      var res = MessageBox.warning(util.translate("scripts", "No existe la subcuenta %1 en el ejercicio %2.\nDesea crearla?").arg(qryCierre.value("codsubcuenta")).arg(ejNuevo), MessageBox.Yes, MessageBox.Cancel);
      if (res != MessageBox.Yes)
        return false;
      idSubcuentaAp = this.iface.crearSubcuentaApertura(qryCierre.value("codsubcuenta"), ejNuevo);
      if (!idSubcuentaAp)
        return false;
    }
    curApertura.setModeAccess(curApertura.Insert);
    curApertura.refreshBuffer();
    curApertura.setValueBuffer("concepto", util.translate("scripts", "Asiento de apertura de ejercicio ") + nombreEjercicio);
    curApertura.setValueBuffer("idsubcuenta", idSubcuentaAp);
    curApertura.setValueBuffer("codsubcuenta", qryCierre.value("codsubcuenta"));
    curApertura.setValueBuffer("idasiento", idAsiento);
    curApertura.setValueBuffer("debe", qryCierre.value("haber"));
    curApertura.setValueBuffer("haber", qryCierre.value("debe"));
    curApertura.setValueBuffer("coddivisa", qryCierre.value("coddivisa"));
    curApertura.setValueBuffer("tasaconv", qryCierre.value("tasaconv"));
    curApertura.setValueBuffer("debeME", qryCierre.value("haberME"));
    curApertura.setValueBuffer("haberME", qryCierre.value("debeME"));
    util.setProgress(paso++);
    if (!curApertura.commitBuffer()) {
      util.destroyProgressDialog();
      return false;
    }
  }
  if (!util.sqlUpdate("ejercicios", "idasientoapertura", idAsiento, "codejercicio = '" + ejNuevo + "'")) {
    util.destroyProgressDialog();
    return false;
  }
  curAsiento.select("idasiento = " + idAsiento);
  curAsiento.first();
  curAsiento.setModeAccess(curAsiento.Edit);
  curAsiento.refreshBuffer();
  curAsiento.setUnLock("editable", false);
  util.destroyProgressDialog();
  return true;
}
/** \C
Abre un cuadro de dilogo que permite seleccionar el ejercicio en el que se crear el asiento de apertura. Dicho ejercicio debe estar abierto y ser posterior al actual
\end */
function tbnEjercicio_clicked5()
{
  var f = new FLFormSearchDB("ejercicios");
  f.setMainWidget();
  f.cursor().setMainFilter("estado = 'ABIERTO'" +
                           " AND fechainicio > '" + this.cursor().valueBuffer("fechainicio") + "'");
  var codEjercicio = f.exec("codejercicio");
  if (codEjercicio) {
    this.child("ledEjercicio").text = codEjercicio;
  }
}
/** \D Si se ha seleccionado el asiento de apertura, se comprueba que se ha seleccionado un ejercicio para ubicar dicho asiento y de que el mencionado ejercicio no tiene ya un asiento de apertura
@return true en caso de que el cierre sea posible, false en caso contrario
\end */
function validarCierre6()
{
  debug("VC");
  var util = new FLUtil();
  if (this.child("ckbAsientoApertura").checked == true) {
    if (this.child("ledEjercicio").text == "") {
      MessageBox.warning(util.translate("scripts", "Debe seleccionar el ejercicio sobre el que se crear el asiento de apertura"), MessageBox.Ok, MessageBox.NoButton);
      return false;
    }
    var numAsientoApertura = util.sqlSelect("ejercicios,co_asientos", "co_asientos.numero", "co_asientos.idasiento=ejercicios.idasientoapertura AND ejercicios.codejercicio = '" + this.child("ledEjercicio").text + "'");
    if (numAsientoApertura) {
      MessageBox.warning(util.translate("scripts", "El ejercicio seleccionado tiene ya un asiento de apertura, borre el asiento o cambie el ejercicio.\nEl asiento de apertura para el ejercicio seleccionado es el nmero ") + numAsientoApertura, MessageBox.Ok, MessageBox.NoButton);
      return false;
    }
  }
  if (!this.iface.comprobarPartidasHuerfanas()) {
    MessageBox.critical(util.translate("scripts", "Existen partidas sin asiento asociado para el ejercicio actual. Esto no debera ocurrir. Contacte con InfoSiAL para solucionar el problema."), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  debug("VC OK");
  return true;
}
/** \D Comprueba si hay partidas sin asiento para evitar cierres errneos.
\end */
function comprobarPartidasHuerfanas10()
{
  var util = new FLUtil;
  var cursor = this.cursor();
  var codEjercicio = cursor.valueBuffer("codejercicio");
  debug("codEjercicio " + codEjercicio);
  if (util.sqlSelect("co_subcuentas s INNER JOIN co_partidas p ON s.idsubcuenta = p.idsubcuenta LEFT OUTER JOIN co_asientos a ON p.idasiento = a.idasiento", "p.idpartida", "s.codejercicio = '" + codEjercicio + "' AND a.idasiento IS NULL", "co_subcuentas,co_partidas,co_asientos")) {
    return false;
  }
  return true;
}
/** \D Se revierte el proceso de cierre del ejercicio debido a algn fallo previo
\end */
function rollbackCierre7()
{
  this.close();
  return;
  var cursor = this.cursor();
  var codEjercicio = cursor.valueBuffer("codejercicio");
  cursor.setAskForCancelChanges(false);
  cursor.rollback();
  cursor.transaction(false);
  cursor.select("codejercicio = '" + codEjercicio + "'");
  cursor.first();
  cursor.setModeAccess(cursor.Edit);
  cursor.refreshBuffer();
}
function comprobarSaldos8()
{
  var util = new FLUtil;
  var qrySaldos = new FLSqlQuery;
  qrySaldos.setTablesList("co_subcuentas");
  qrySaldos.setSelect("idsubcuenta");
  qrySaldos.setFrom("co_subcuentas");
  qrySaldos.setWhere("codejercicio = '" + this.cursor().valueBuffer("codejercicio") + "'");
  try {
    qrySaldos.setForwardOnly(true);
  } catch (e) {}
  if (!qrySaldos.exec())
    return false;
  util.createProgressDialog(util.translate("scripts", "Revisando saldos"), qrySaldos.size());
  var progress = 0;
  while (qrySaldos.next()) {
    util.setProgress(progress++);
    if (!flcontppal.iface.pub_calcularSaldo(qrySaldos.value(0))) {
      util.destroyProgressDialog();
      return false;
    }
  }
  util.destroyProgressDialog();
  return true;
}
/** \C Crea la subcuenta indicada en el ejercicio indicado
@param  codSubcuenta: Subcuenta a crear.
@param  ejNuevo: Ejercicio en el que se crear la subcuenta
@return Id de la subcuenta creada o false si hay error
\end */
function crearSubcuentaApertura9(codSubcuenta: String, ejNuevo: String)
{
  var util = new FLUtil;
  var cursor = this.cursor();
  var codCuentaAnt = util.sqlSelect("co_subcuentas", "codcuenta", "codsubcuenta = '" + codSubcuenta + "' AND codejercicio = '" + cursor.valueBuffer("codejercicio") + "'");
  if (!codCuentaAnt)
    return false;
  var descripcion = util.sqlSelect("co_subcuentas", "descripcion", "codsubcuenta = '" + codSubcuenta + "' AND codejercicio = '" + cursor.valueBuffer("codejercicio") + "'");
  if (!descripcion)
    return false;
  var codDivisa = util.sqlSelect("co_subcuentas", "coddivisa", "codsubcuenta = '" + codSubcuenta + "' AND codejercicio = '" + cursor.valueBuffer("codejercicio") + "'");
  if (!codDivisa)
    return false;
  var idCuentaNueva = util.sqlSelect("co_cuentas", "idcuenta", "codcuenta = '" + codCuentaAnt + "' AND codejercicio = '" + ejNuevo + "'");
  if (!idCuentaNueva) {
    MessageBox.warning(util.translate("scripts", "Error al generar la subcuenta %1 para el ejercicio %2.\nNo existe la cuenta %3 asociada a la nueva subcuenta.").arg(codSubcuenta).arg(ejNuevo).arg(codCuentaAnt), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  var curSubcuenta = new FLSqlCursor("co_subcuentas");
  curSubcuenta.setForwardOnly(true);
  with(curSubcuenta) {
    setModeAccess(Insert);
    refreshBuffer();
    setValueBuffer("codsubcuenta", codSubcuenta);
    setValueBuffer("descripcion", descripcion);
    setValueBuffer("codcuenta", codCuentaAnt);
    setValueBuffer("idcuenta", idCuentaNueva);
    setValueBuffer("codejercicio", ejNuevo);
    setValueBuffer("coddivisa", codDivisa);
  }
  if (!curSubcuenta.commitBuffer())
    return false;
  return curSubcuenta.valueBuffer("idsubcuenta");
}
function validarCierre11()
{
  var util = new FLUtil();
  var codEjercicioAnt = this.cursor().valueBuffer("codejercicio");
  var codEjercicioAct = this.child("ledEjercicio").text;
  if (!codEjercicioAct)
    return this.iface.__validarCierre();
  var planContableAnt = util.sqlSelect("ejercicios", "plancontable", "codejercicio = '" + codEjercicioAnt + "'");
  var planContableAct = util.sqlSelect("ejercicios", "plancontable", "codejercicio = '" + codEjercicioAct + "'");
  // Si se pasa del 90 al 08 hay que comprobar cuentas hurfanas
  if (planContableAnt != "08" && planContableAct == "08")
    if (!this.iface.comprobarSaldosHuerfanos())
      return false;
  // No se puede pasar del 08 al 90
  if (planContableAnt == "08" && planContableAct != "08") {
    MessageBox.information(util.translate("scripts", "No es posible crear el asiento de apertura en un ejercicio con PGC 90\nporque el ejercicio que se est cerrando corresponde a un PGC 08"),
                           MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  if (!flcontinfo.iface.cuentasSinCB(codEjercicioAnt))
    return false;
  return this.iface.__validarCierre();
}
/** Se comprueban los saldos de las subcuentas que no tienen correspondencias
en el nuevo PGC. Si hay alguna, se da un aviso
*/
function comprobarSaldosHuerfanos13()
{
  var util = new FLUtil;
  var curCbl = new FLSqlCursor("co_subcuentas");
  curCbl.setForwardOnly(true);
  var codEjercicio = this.cursor().valueBuffer("codejercicio");
  var saldos = "";
  var saldo: Number;
  var paso = 0;
  curCbl.select("codejercicio = '" + codEjercicio + "' and saldo <> 0");
  util.createProgressDialog(util.translate("scripts", "Comprobando cuentas"), curCbl.size());
  while (curCbl.next()) {
    util.setProgress(paso++);
    codCuenta08 = util.sqlSelect("co_correspondenciascc", "codigo08", "codigo90 = '" + curCbl.valueBuffer("codcuenta") + "'");
    if (!codCuenta08) {
      saldo = parseFloat(curCbl.valueBuffer("saldo"));
      saldos += "\n" + curCbl.valueBuffer("codsubcuenta") + "   -   " + util.buildNumber(saldo, "f", 2);
    }
  }
  util.destroyProgressDialog();
  if (saldos) {
    MessageBox.information(util.translate("scripts",
                                          "Algunas subcuentas que ya no existen en el nuevo PGC tienen saldos\nen el ejercicio que se est cerrando.\nDeber trasladar el saldo de estas subcuentas a otras o bien establecer\n su correspondencia en las opciones del mdulo principal de financiera y repetir el cierre\n\nLas subcuentas y sus saldos son:") + "\n" + saldos,
                           MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    this.iface.rollbackCierre();
    return false;
  }
  return true;
}
function asientoPyG15()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  var codEjercicio = cursor.valueBuffer("codejercicio");
  var planContable = util.sqlSelect("ejercicios", "plancontable", "codejercicio = '" + codEjercicio + "'");
  if (planContable != "08")
    return this.iface.__asientoPyG();
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.setForwardOnly(true);
  curAsiento.setModeAccess(curAsiento.Insert);
  curAsiento.refreshBuffer();
  curAsiento.setValueBuffer("numero", 0);
  curAsiento.setValueBuffer("fecha", this.child("dedFecha").date);
  curAsiento.setValueBuffer("codejercicio", cursor.valueBuffer("codejercicio"));
  if (!curAsiento.commitBuffer())
    return false;
  var idAsiento = curAsiento.valueBuffer("idasiento");
  var curPartida = new FLSqlCursor("co_partidas");
  curPartida.setForwardOnly(true);
  var debe = 0;
  var haber = 0;
  var totalDebe = 0;
  var totalHaber = 0;
  var paso = 0;
  // select s.codsubcuenta,s.codcuenta,s.idsubcuenta,s.saldo from co_subcuentas s inner join co_cuentas c on s.idcuenta=c.idcuenta where s.codejercicio='0002' and c.codcuenta like '430%' and s.saldo <> 0;
  var qSC = new FLSqlQuery();
  qSC.setForwardOnly(true);
  qSC.setTablesList("co_subcuentas,co_cuentas");
  qSC.setFrom("co_subcuentas s inner join co_cuentas c on s.idcuenta=c.idcuenta");
  qSC.setSelect("s.saldo, s.idsubcuenta, s.codsubcuenta");
  //  select codcuenta from co_cuentascb where codbalance like 'PG-%' order by codcuenta;
  var q = new FLSqlQuery();
  q.setForwardOnly(true);
  q.setTablesList("co_cuentascb");
  q.setFrom("co_cuentascb");
  q.setSelect("codcuenta");
  q.setWhere("codbalance like 'PG-%'");
  if (!q.exec())
    return false;
  util.createProgressDialog(util.translate("scripts", "Creando asiento de regularizacin..."), q.size());
  util.setProgress(1);
  while (q.next()) {
    qSC.setWhere("s.codejercicio='" + codEjercicio + "' and c.codcuenta like '" + q.value(0) + "%' and s.saldo <> 0 order by codsubcuenta");
    qSC.exec();
    while (qSC.next()) {
      if (parseFloat(qSC.value(0)) > 0) {
        debe = 0;
        haber = parseFloat(qSC.value(0));
      } else {
        debe = 0 - parseFloat(qSC.value(0));
        haber = 0;
      }
      totalDebe += debe;
      totalHaber += haber;
      curPartida.setModeAccess(curPartida.Insert);
      curPartida.refreshBuffer();
      curPartida.setValueBuffer("concepto", util.translate("scripts", "Regularizacin ejercicio ") +
                                cursor.valueBuffer("nombre"));
      curPartida.setValueBuffer("idsubcuenta", qSC.value(1));
      curPartida.setValueBuffer("codsubcuenta", qSC.value(2));
      curPartida.setValueBuffer("idasiento", idAsiento);
      curPartida.setValueBuffer("debe", debe);
      curPartida.setValueBuffer("haber", haber);
      curPartida.setValueBuffer("coddivisa", this.iface.divisaEmpresa);
      curPartida.setValueBuffer("tasaconv", 1);
      curPartida.setValueBuffer("debeME", 0);
      curPartida.setValueBuffer("haberME", 0);
      if (!curPartida.commitBuffer()) {
        util.destroyProgressDialog();
        return false;
      }
    }
    util.setProgress(paso++);
  }
  var ctaPyG = flfactppal.iface.pub_ejecutarQry("co_subcuentas s INNER JOIN co_cuentas c ON s.idcuenta = c.idcuenta INNER JOIN co_cuentascb cb ON c.codcuenta = cb.codcuenta", "idsubcuenta,codsubcuenta", "cb.codbalance = 'P-A-1-VII-' AND c.codejercicio = '" + cursor.valueBuffer("codejercicio") + "'", "co_subcuentas,co_cuentas,co_cuentascb");
  if (ctaPyG.result != 1) {
    util.destroyProgressDialog();
    MessageBox.warning(util.translate("scripts",
                                      "Error en la bsqueda de la cuenta de prdidas y ganancias"),
                       MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  if (totalDebe > totalHaber) {
    debe = 0;
    haber = totalDebe - totalHaber;
  } else {
    debe = totalHaber - totalDebe;
    haber = 0;
  }
  curPartida.setModeAccess(curPartida.Insert);
  curPartida.refreshBuffer();
  curPartida.setValueBuffer("concepto", util.translate("scripts", "Regularizacin ejercicio ") + cursor.valueBuffer("nombre"));
  curPartida.setValueBuffer("idsubcuenta", ctaPyG.idsubcuenta);
  curPartida.setValueBuffer("codsubcuenta", ctaPyG.codsubcuenta);
  curPartida.setValueBuffer("idasiento", idAsiento);
  curPartida.setValueBuffer("debe", debe);
  curPartida.setValueBuffer("haber", haber);
  curPartida.setValueBuffer("coddivisa", this.iface.divisaEmpresa);
  curPartida.setValueBuffer("tasaconv", 1);
  curPartida.setValueBuffer("debeME", 0);
  curPartida.setValueBuffer("haberME", 0);
  if (!curPartida.commitBuffer()) {
    util.destroyProgressDialog();
    return false;
  }
  curAsiento.select("idasiento = " + idAsiento);
  curAsiento.first();
  curAsiento.setModeAccess(curAsiento.Edit);
  curAsiento.refreshBuffer();
  curAsiento.setUnLock("editable", false);
  cursor.setValueBuffer("idasientopyg", idAsiento);
  util.destroyProgressDialog();
  return true;
}
function asientoCierre14()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  var codEjercicio = cursor.valueBuffer("codejercicio");
  var planContable = util.sqlSelect("ejercicios", "plancontable", "codejercicio = '" + codEjercicio + "'");
  if (planContable != "08")
    return this.iface.__asientoCierre();
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.setForwardOnly(true);
  curAsiento.setModeAccess(curAsiento.Insert);
  curAsiento.refreshBuffer();
  curAsiento.setValueBuffer("numero", 0);
  curAsiento.setValueBuffer("fecha", this.child("dedFecha").date);
  curAsiento.setValueBuffer("codejercicio", cursor.valueBuffer("codejercicio"));
  if (!curAsiento.commitBuffer())
    return false;
  var idAsiento = curAsiento.valueBuffer("idasiento");
  var curPartida = new FLSqlCursor("co_partidas");
  curPartida.setForwardOnly(true);
  var debe = 0;
  var haber = 0;
  var totalDebe = 0;
  var totalHaber = 0;
  var paso = 0;
  // select s.codsubcuenta,s.codcuenta,s.idsubcuenta,s.saldo from co_subcuentas s inner join co_cuentas c on s.idcuenta=c.idcuenta where s.codejercicio='0002' and c.codcuenta like '430%' and s.saldo <> 0;
  var qSC = new FLSqlQuery();
  qSC.setForwardOnly(true);
  qSC.setTablesList("co_subcuentas,co_cuentas");
  qSC.setFrom("co_subcuentas s inner join co_cuentas c on s.idcuenta=c.idcuenta");
  qSC.setSelect("s.saldo, s.idsubcuenta, s.codsubcuenta");
  //  select codcuenta from co_cuentascb where codbalance like 'A-%' or codbalance like 'P-%' order by codcuenta;
  var q = new FLSqlQuery();
  q.setForwardOnly(true);
  q.setTablesList("co_cuentascb");
  q.setFrom("co_cuentascb");
  q.setSelect("codcuenta");
  q.setWhere("codbalance like 'A-%' or codbalance like 'P-%' order by codcuenta");
  if (!q.exec())
    return false;
  util.createProgressDialog(util.translate("scripts", "Creando asiento de cierre..."), q.size());
  util.setProgress(1);
  while (q.next()) {
    qSC.setWhere("s.codejercicio='" + codEjercicio + "' and c.codcuenta like '" + q.value(0) + "%' and s.saldo <> 0 order by codsubcuenta");
    qSC.exec();
    while (qSC.next()) {
      if (parseFloat(qSC.value(0)) > 0) {
        debe = 0;
        haber = parseFloat(qSC.value(0));
      } else {
        debe = 0 - parseFloat(qSC.value(0));
        haber = 0;
      }
      totalDebe += debe;
      totalHaber += haber;
      curPartida.setModeAccess(curPartida.Insert);
      curPartida.refreshBuffer();
      curPartida.setValueBuffer("concepto", util.translate("scripts", "Asiento de cierre de ejercicio ") +
                                cursor.valueBuffer("nombre"));
      curPartida.setValueBuffer("idsubcuenta", qSC.value(1));
      curPartida.setValueBuffer("codsubcuenta", qSC.value(2));
      curPartida.setValueBuffer("idasiento", idAsiento);
      curPartida.setValueBuffer("debe", debe);
      curPartida.setValueBuffer("haber", haber);
      curPartida.setValueBuffer("coddivisa", this.iface.divisaEmpresa);
      curPartida.setValueBuffer("tasaconv", 1);
      curPartida.setValueBuffer("debeME", 0);
      curPartida.setValueBuffer("haberME", 0);
      if (!curPartida.commitBuffer()) {
        util.destroyProgressDialog();
        return false;
      }
    }
    util.setProgress(paso++);
  }
  if (parseFloat(totalDebe) -  parseFloat(totalHaber) > 0.01) {
    MessageBox.critical(util.translate("scripts",
                                       "Asiento de cierre: los totales de debe y haber no coinciden\n" +
                                       "DEBE : " + Math.round(parseFloat(totalDebe)) + "  HABER : " + Math.round(parseFloat(totalHaber))),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    util.destroyProgressDialog();
    return false;
  }
  curAsiento.select("idasiento = " + idAsiento);
  curAsiento.first();
  curAsiento.setModeAccess(curAsiento.Edit);
  curAsiento.refreshBuffer();
  curAsiento.setUnLock("editable", false);
  cursor.setValueBuffer("estado", "CERRADO");
  cursor.setValueBuffer("idasientocierre", idAsiento);
  util.destroyProgressDialog();
  return true;
}
function asientoApertura12(idAsientoCierre, ejNuevo)
{
  var util = new FLUtil();
  if (!ejNuevo) {
    return false;
  }
  if (!util.sqlSelect("co_subcuentas", "idsubcuenta", "codejercicio = '" + ejNuevo + "' AND idsubcuenta <> 0")) {
    return false;
  }
  var datosEjercicio = flfactppal.iface.pub_ejecutarQry("ejercicios", "fechainicio,nombre,plancontable,longsubcuenta", "codejercicio = '" + ejNuevo + "'");
  if (datosEjercicio.plancontable != "08") {
    return this.iface.__asientoApertura(idAsientoCierre, ejNuevo);
  }
  var ejAnterior = util.sqlSelect("co_asientos", "codejercicio", "idasiento = " + idAsientoCierre);
  var curAsiento = new FLSqlCursor("co_asientos");
  curAsiento.setForwardOnly(true);
  var fechaAsiento = datosEjercicio.fechainicio;
  var nombreEjercicio = datosEjercicio.nombre;
  var planContableAnt = util.sqlSelect("ejercicios", "plancontable", "codejercicio = '" + ejAnterior + "'");
  if (planContableAnt != "08") {
    if (!this.iface.comprobarSubcuentas08(idAsientoCierre, ejNuevo)) {
      return false;
    }
  }
  curAsiento.setModeAccess(curAsiento.Insert);
  curAsiento.refreshBuffer();
  curAsiento.setValueBuffer("numero", 0);
  curAsiento.setValueBuffer("fecha", fechaAsiento);
  curAsiento.setValueBuffer("codejercicio", ejNuevo);
  if (!curAsiento.commitBuffer()) {
    return false;
  }
  var idAsiento = curAsiento.valueBuffer("idasiento");
  var qryCierre = new FLSqlQuery();
  qryCierre.setForwardOnly(true);
  with(qryCierre) {
    setTablesList("co_partidas");
    setSelect("codsubcuenta, debe, haber, coddivisa, tasaconv, debeME, haberME");
    setFrom("co_partidas");
    setWhere("idasiento = " + idAsientoCierre);
  }
  if (!qryCierre.exec()) {
    return false;
  }
  // Es necesario migrar el resultado de la 129 a la 120 o 121 (resultados de ejercicio anteriores)
  var codSubcuentaPyG: String;
  if (planContableAnt == "08") {
    codSubcuentaPyG = util.sqlSelect("co_subcuentas s INNER JOIN co_cuentas c ON s.idcuenta = c.idcuenta INNER JOIN co_cuentascb cb ON c.codcuenta = cb.codcuenta", "codsubcuenta", "cb.codbalance = 'P-A-1-VII-' AND c.codejercicio = '" + ejAnterior + "'", "co_subcuentas,co_cuentas,co_cuentascb");
  } else {
    var ctaPyG = flfacturac.iface.pub_datosCtaEspecial("PYG", ejAnterior);
    codSubcuentaPyG = ctaPyG.codsubcuenta;
  }
  var codSubcuentaPyGPos = util.sqlSelect("co_subcuentas s INNER JOIN co_cuentas c ON s.idcuenta = c.idcuenta INNER JOIN co_cuentascb cb ON c.codcuenta = cb.codcuenta", "codsubcuenta", "cb.codbalance = 'P-A-1-V-1' AND c.codejercicio = '" + ejNuevo + "'", "co_subcuentas,co_cuentas,co_cuentascb");
  var codSubcuentaPyGNeg = util.sqlSelect("co_subcuentas s INNER JOIN co_cuentas c ON s.idcuenta = c.idcuenta INNER JOIN co_cuentascb cb ON c.codcuenta = cb.codcuenta", "codsubcuenta", "cb.codbalance = 'P-A-1-V-2' AND c.codejercicio = '" + ejNuevo + "'", "co_subcuentas,co_cuentas,co_cuentascb");
  util.createProgressDialog(util.translate("scripts", "Creando asiento de apertura..."), qryCierre.size());
  util.setProgress(1);
  var curApertura = new FLSqlCursor("co_partidas");
  curApertura.setForwardOnly(true);
  var paso = 0;
  var idSubcuentaAp: String;
  var codSubcuenta08: String;
  var numCeros: Number;
  while (qryCierre.next()) {
    if (planContableAnt == "08") {
      codSubcuenta08 = qryCierre.value("codsubcuenta");
    } else {
      codSubcuenta08 = flcontppal.iface.convertirCodSubcuenta(ejAnterior, qryCierre.value("codsubcuenta"));
      if (!codSubcuenta08) {
        MessageBox.critical(util.translate("scripts", "No se encuentra la correspondencia entre la cuenta correspondiente a la subcuenta %0 en el ejercicio %0.\nDeber migrar el saldo de esta subcuenta a otra y repetir el cierre").arg(qryCierre.value("codsubcuenta")).arg(ejAnterior), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
        util.destroyProgressDialog();
        return false;
      }
    }
    if (qryCierre.value("codsubcuenta") == codSubcuentaPyG) {
      if (qryCierre.value("debe") - qryCierre.value("haber") > 0) {
        codSubcuenta08 = codSubcuentaPyGPos;
      } else {
        codSubcuenta08 = codSubcuentaPyGNeg;
      }
    }
    idSubcuentaAp = util.sqlSelect("co_subcuentas", "idsubcuenta", "codsubcuenta = '" + codSubcuenta08 + "' AND codejercicio = '" + ejNuevo + "'");
    if (!idSubcuentaAp) {
      util.destroyProgressDialog();
      var res = MessageBox.warning(util.translate("scripts", "No existe la subcuenta %1 en el ejercicio %2.\nDesea crearla?").arg(codSubcuenta08).arg(ejNuevo), MessageBox.Yes, MessageBox.Cancel);
      if (res != MessageBox.Yes) {
        return false;
      }
      idSubcuentaAp = this.iface.crearSubcuentaApertura(codSubcuenta08, ejNuevo);
      if (!idSubcuentaAp) {
        return false;
      }
    }
    curApertura.setModeAccess(curApertura.Insert);
    curApertura.refreshBuffer();
    curApertura.setValueBuffer("concepto", util.translate("scripts", "Asiento de apertura de ejercicio ") + nombreEjercicio);
    curApertura.setValueBuffer("idsubcuenta", idSubcuentaAp);
    curApertura.setValueBuffer("codsubcuenta", codSubcuenta08);
    curApertura.setValueBuffer("idasiento", idAsiento);
    curApertura.setValueBuffer("debe", qryCierre.value("haber"));
    curApertura.setValueBuffer("haber", qryCierre.value("debe"));
    curApertura.setValueBuffer("coddivisa", qryCierre.value("coddivisa"));
    curApertura.setValueBuffer("tasaconv", qryCierre.value("tasaconv"));
    curApertura.setValueBuffer("debeME", qryCierre.value("haberME"));
    curApertura.setValueBuffer("haberME", qryCierre.value("debeME"));
    util.setProgress(paso++);
    if (!curApertura.commitBuffer()) {
      util.destroyProgressDialog();
      return false;
    }
  }
  if (!util.sqlUpdate("ejercicios", "idasientoapertura", idAsiento, "codejercicio = '" + ejNuevo + "'")) {
    util.destroyProgressDialog();
    return false;
  }
  curAsiento.select("idasiento = " + idAsiento);
  curAsiento.first();
  curAsiento.setModeAccess(curAsiento.Edit);
  curAsiento.refreshBuffer();
  curAsiento.setUnLock("editable", false);
  util.destroyProgressDialog();
  return true;
}
function comprobarSubcuentas0816(idAsientoCierre, ejNuevo)
{
  var util = new FLUtil();
  if (!ejNuevo) {
    return false;
  }
  if (!util.sqlSelect("co_subcuentas", "idsubcuenta", "codejercicio = '" + ejNuevo + "' AND idsubcuenta <> 0")) {
    return false;
  }
  var qryCierre = new FLSqlQuery();
  qryCierre.setForwardOnly(true);
  with(qryCierre) {
    setTablesList("co_partidas");
    setSelect("codsubcuenta, debe, haber, coddivisa, tasaconv, debeME, haberME");
    setFrom("co_partidas");
    setWhere("idasiento = " + idAsientoCierre);
  }
  if (!qryCierre.exec())
    return false;
  var paso = 0;
  var idSubcuentaAp: String;
  var codSubcuenta08: String;
  var numCeros: Number;
  var faltan = "";
  util.createProgressDialog(util.translate("scripts", "Comprobando subcuentas del nuevo ejercicio..."), qryCierre.size());
  while (qryCierre.next()) {
    util.setProgress(paso++);
    codSubcuenta08 = flcontppal.iface.convertirCodSubcuenta(this.cursor().valueBuffer("codejercicio"), qryCierre.value("codsubcuenta"));
    idSubcuentaAp = util.sqlSelect("co_subcuentas", "idsubcuenta", "codsubcuenta = '" + codSubcuenta08 + "' AND codejercicio = '" + ejNuevo + "'");
    if (!idSubcuentaAp)
      idSubcuentaAp = this.iface.crearSubcuentaApertura(codSubcuenta08, ejNuevo);
    idSubcuentaAp = util.sqlSelect("co_subcuentas", "idsubcuenta", "codsubcuenta = '" + codSubcuenta08 + "' AND codejercicio = '" + ejNuevo + "'");
    if (!idSubcuentaAp)
      faltan += "\n" + codSubcuenta08 + " (Subcuenta ejercicio anterior: " + qryCierre.value("codsubcuenta") + ")";
  }
  util.destroyProgressDialog();
  if (faltan) {
    MessageBox.critical(util.translate("scripts", "Las siguientes subcuentas no existen en el nuevo ejercicio. Debe crearlas antes de proceder al cierre:\n") + faltan,
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
