//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_cuentas.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var ejercicioActual: String;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function calculateField(fN: String)
  {
    return this.ctx.calculateField1(fN);
  }
  function validateForm()
  {
    return this.ctx.validateForm2();
  }
  function desconexion()
  {
    return this.ctx.desconexion3();
  }
  function bufferChanged(fN)
  {
    return this.ctx.bufferChanged4(fN);
  }
  function init()
  {
    this.ctx.init5();
  }
}
const iface = new interna(this);
/** \C En modo edicin. Los campos referentes al epgrafe del que procede la cuenta estarn inhabilitados. No se permitir editar el tipo de cuenta especial si la cuenta tiene subcuentas asociadas
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  switch (cursor.modeAccess()) {
    case cursor.Insert:
      cursor.setValueBuffer("codejercicio", this.iface.ejercicioActual);
      break;
    case cursor.Edit:
      this.child("fdbIdEpigrafe").setDisabled(true);
      this.child("fdbCodEpigrafe").setDisabled(true);
      break;
  }
  this.child("fdbIdEpigrafe").setFilter("codejercicio = '" + this.iface.ejercicioActual + "'");
  connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
  connect(this, "closed()", this, "iface.desconexion");
}
function calculateField1(fN)
{
  var util = new FLUtil();
  var res: Object;
  var cursor = this.cursor();
  switch (fN) {
      /** \D El --codcuenta-- toma como prefijo el --codepigrafe-- al que pertenece
      \end */
    case "codcuenta":
      res = cursor.valueBuffer("codepigrafe");
      break;
      /** \D El --idepigrafe-- debe corresponder al ejercicio actual
      \end */
    case "idepigrafe":
      res = util.sqlSelect("co_epigrafes", "idepigrafe", "codejercicio = '" + this.iface.ejercicioActual + "'" + " AND codepigrafe = '" + cursor.valueBuffer("codepigrafe") + "'");
      break;
  }
  return res;
}
function validateForm2()
{
  var cursor = this.cursor();
  var util = new FLUtil();
  /** \C El cdigo de cuenta tendr como prefijo el cdigo del epgrafe al que pertenece
  \end */
  var codEpigrafe = cursor.valueBuffer("codepigrafe");
  var codCuenta = cursor.valueBuffer("codcuenta");
  if (codEpigrafe != codCuenta.substring(0, codEpigrafe.length)) {
    MessageBox.critical(util.translate("scripts",
                                       "El cdigo de la cuenta debe tener como prefijo el de su epgrafe padre"),
                        MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function desconexion3()
{
  disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}
function bufferChanged4(fN)
{
  switch (fN) {
      /** \C Al cambiar el --codepigrafe-- el --codcuenta-- tomar el mismo valor que el --codepigrafe--
      \end */
    case "codepigrafe":
      this.child("fdbCodCuenta").setValue(this.iface.calculateField("codcuenta"));
      this.child("fdbIdEpigrafe").setValue(this.iface.calculateField("idepigrafe"));
      break;
  }
}
function init5()
{
  this.iface.__init();
  var util = new FLUtil();
  if (util.sqlSelect("ejercicios", "plancontable", "codejercicio = '" + this.cursor().valueBuffer("codejercicio") + "'") == "08")
    this.child("fdbCodBalance").setDisabled(true);
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
