//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_cuentasesp.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var posActualPuntoSubcuenta: Number;
  var ejercicioActual: String;
  var longSubcuenta: Number;
  var bloqueoSubcuenta: Boolean;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function bufferChanged(fN)
  {
    return this.ctx.bufferChanged2(fN);
  }
}
const iface = new interna(this);
function init0()
{
  var util = new FLUtil();
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  this.iface.longSubcuenta = util.sqlSelect("ejercicios", "longsubcuenta",  "codejercicio = '" + this.iface.ejercicioActual + "'");
  this.iface.posActualPuntoSubcuenta = -1;
  this.iface.bloqueoSubcuenta = false;
  connect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}
function validateForm1()
{
  var cursor = this.cursor();
  var util = new FLUtil();
  /** \C
  La longitud del cdigo de subcuenta debe coincidir con la longitud de subcuenta asignada al ejercicio actual
  \end */
  var codSubcuenta = cursor.valueBuffer("codsubcuenta");
  if (!codSubcuenta.length)
    return true;
  if (codSubcuenta.length != this.iface.longSubcuenta) {
    MessageBox.warning(util.translate("MetaData",
                                      "El cdigo de subcuenta debe tener la longitud establecida para el ejercicio actual: ") +
                       this.iface.longSubcuenta,
                       MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function bufferChanged2(fN)
{
  var cursor = this.cursor();
  debug(fN);
  switch (fN) {
      /*U Al introducir --codsubcuenta--, si el usuario pulsa la tecla del punto '.', la subcuenta se informa automaticamente con el cdigo de cuenta ms tantos ceros como sea necesario para completar la longitud de subcuenta asociada al ejercicio actual.
      \end */
    case "codsubcuenta":
      if (!this.iface.bloqueoSubcuenta) {
        this.iface.bloqueoSubcuenta = true;
        this.iface.posActualPuntoSubcuenta = flcontppal.iface.pub_formatearCodSubcta(this, "fdbCodSubcuenta", this.iface.longSubcuenta, this.iface.posActualPuntoSubcuenta);
        this.iface.bloqueoSubcuenta = false;
      }
      break;
  }
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
