//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_masteramortizaciones.qs  -  description
-------------------
begin                : mar mar 03 2010
copyright            : (C) 2010 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var tdbRecords: FLTableDB;
  var pbnGenerar: String;
  var msgDotaciones_: String;
  var importeDot_;
  var numDotaciones_;
  var cantidadDot_;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function pbnGenerar_clicked()
  {
    return this.ctx.pbnGenerar_clicked1();
  }
  function generarDotaciones(fechaLimite)
  {
    return this.ctx.generarDotaciones2(fechaLimite);
  }
  function generarDotacionesAmor(qryAmor, fechaLimite)
  {
    return this.ctx.generarDotacionesAmor3(qryAmor, fechaLimite);
  }
  function filtrarTabla()
  {
    return this.ctx.filtrarTabla4();
  }
  function filtroTabla()
  {
    return this.ctx.filtroTabla5();
  }
  function dameFiltroGenerarDotaciones()
  {
    return this.ctx.dameFiltroGenerarDotaciones6();
  }
}
const iface = new interna(this);
/** \C El formulario mostrar las cuentas asociadas al ejercicio actual
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.tdbRecords = this.child("tableDBRecords");
  this.iface.pbnGenerar = this.child("pbnGenerar");
  connect(this.iface.pbnGenerar, "clicked()", this, "iface.pbnGenerar_clicked"),
          this.iface.filtrarTabla();
}
function pbnGenerar_clicked1()
{
  var util = new FLUtil;
  var dialog = new Dialog;
  dialog.caption = "Introduzca la fecha lmite de las dotaciones a generar";
  dialog.okButtonText = util.translate("scripts", "OK");
  dialog.cancelButtonText = util.translate("scripts", "Cancelar");
  var hoy = new Date;
  hoy.setDate(1);
  var fechaDefecto = util.addMonths(hoy, 1);
  fechaDefecto = util.addDays(fechaDefecto, -1);
  var dedLimite = new DateEdit;
  dedLimite.label = "Fecha lmite: ";
  dedLimite.date = fechaDefecto;
  dialog.add(dedLimite);
  if (!dialog.exec()) {
    return false;
  }
  var fechaLimite = dedLimite.date;
  if (!fechaLimite || fechaLimite == "") {
    MessageBox.warning(util.translate("scripts", "Debe establecer las fecha lmite"), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  var mesL = fechaLimite.getMonth();
  var fechaComp = util.addDays(fechaLimite, 1);
  var fechaLimiteC = new Date(Date.parse(fechaComp.toString()));
  var mesL = fechaLimite.getMonth();
  var mesLC = fechaLimiteC.getMonth();
  if (mesL == mesLC) {
    MessageBox.warning(util.translate("scripts", "La fecha indicada debe ser fin de mes"), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  this.iface.msgDotaciones_ = "";
  this.iface.importeDot_ = 0;
  this.iface.cantidadDot_ = 0;
  var curTransaccion = new FLSqlCursor("empresa");
  curTransaccion.transaction(false);
  try {
    if (this.iface.generarDotaciones(fechaLimite)) {
      var res = MessageBox.information(util.translate("scripts", "Dotaciones generadas:\n") + this.iface.msgDotaciones_, MessageBox.Ok, MessageBox.Cancel);
      res == MessageBox.Ok ? curTransaccion.commit() : curTransaccion.rollback();
    } else {
      curTransaccion.rollback();
      MessageBox.warning(util.translate("scripts", "Error al generar las dotaciones"), MessageBox.Ok, MessageBox.NoButton);
    }
  } catch (e) {
    curTransaccion.rollback();
    MessageBox.critical(util.translate("scripts", "Error al generar las dotaciones: ") + e, MessageBox.Ok, MessageBox.NoButton);
  }
}
function generarDotaciones2(fechaLimite: Date)
{
  var util = new FLUtil;
  this.iface.numDotaciones_ = 0;
  var where = this.iface.dameFiltroGenerarDotaciones();
  var qryAmor = new FLSqlQuery;
  qryAmor.setTablesList("co_amortizaciones");
  qryAmor.setSelect("codamortizacion, elemento");
  qryAmor.setFrom("co_amortizaciones");
  qryAmor.setWhere(where);
  qryAmor.setForwardOnly(true);
  if (!qryAmor.exec()) {
    return false;
  }
  while (qryAmor.next()) {
    this.iface.msgDotaciones_ += "\n" + util.translate("scripts", "Elemento: %1").arg(qryAmor.value("elemento"));
    if (!this.iface.generarDotacionesAmor(qryAmor, fechaLimite)) {
      return false;
    }
  }
  /// Controla que el mensaje de confirmacin no sea demasiado largo
  if (this.iface.numDotaciones_ == 0) {
    this.iface.msgDotaciones_ = util.translate("scripts", "No es necesario generar dotaciones");
  } else if (this.iface.numDotaciones_ > 25) {
    this.iface.msgDotaciones_ = util.translate("scripts", "Se han generado %1 dotaciones por un total de %2").arg(this.iface.cantidadDot_).arg(util.roundFieldValue(this.iface.importeDot_, "co_dotaciones", "importe"));
  }
  return true;
}
function dameFiltroGenerarDotaciones6()
{
  return "estado = 'En Curso' AND pendiente > 0";
}
function generarDotacionesAmor3(qryAmor: FLSqlQuery, fechaLimite: Date)
{
  var util = new FLUtil;
  var codAmor = qryAmor.value("codamortizacion");
  //  var fechaUltimaDot= util.sqlSelect("co_dotaciones", "fechafin", "codamortizacion = '" + codAmor + "' ORDER BY fechafin DESC");
  //  var dotCompletas= (util.daysTo(fechaUltimaDot, fechaLimite) <= 0);
  var pendiente = parseFloat(util.sqlSelect("co_amortizaciones", "pendiente", "codamortizacion = '" + codAmor + "'"));
  pendiente = (isNaN(pendiente) ? 0 : pendiente);
  var curDotacion = new FLSqlCursor("co_dotaciones");
  var curAmortizacion = new FLSqlCursor("co_amortizaciones");
  var fechaInicio: String, fechaFin: String, importe: Number;
  //  while (pendiente > 0 && !dotCompletas) {
  while (pendiente > 0) {
    curDotacion.setModeAccess(curDotacion.Insert);
    curDotacion.refreshBuffer();
    curDotacion.setValueBuffer("codamortizacion", codAmor);
    fechaInicio = formRecordco_dotaciones.iface.pub_commonCalculateField("fechainicio", curDotacion);
    curDotacion.setValueBuffer("fechainicio", fechaInicio);
    fechaFin = formRecordco_dotaciones.iface.pub_commonCalculateField("fechafin", curDotacion);
    if (util.daysTo(fechaFin, fechaLimite) < 0) {
      break;
    }
    curDotacion.setValueBuffer("fechafin", fechaFin);
    curDotacion.setValueBuffer("fecha", fechaFin);
    importe = formRecordco_dotaciones.iface.pub_commonCalculateField("importeinicio", curDotacion);
    curDotacion.setValueBuffer("importe", importe);
    curDotacion.setValueBuffer("acumulado", formRecordco_dotaciones.iface.pub_commonCalculateField("acumulado", curDotacion));
    curDotacion.setValueBuffer("resto", formRecordco_dotaciones.iface.pub_commonCalculateField("resto", curDotacion));
    curDotacion.setValueBuffer("porcentaje", formRecordco_dotaciones.iface.pub_commonCalculateField("porcentaje", curDotacion));
    if (!curDotacion.commitBuffer()) {
      return false;
    }
    this.iface.msgDotaciones_ += "\n\t" + util.translate("scripts", "Dotacin: Desde %1 hasta %2. Importe: %3").arg(util.dateAMDtoDMA(fechaInicio)).arg(util.dateAMDtoDMA(fechaFin)).arg(util.roundFieldValue(importe, "co_dotaciones", "importe"));
    this.iface.importeDot_ += parseFloat(importe);
    this.iface.cantidadDot_++;
    curAmortizacion.select("codamortizacion = '" + codAmor + "'");
    if (!curAmortizacion.first()) {
      return false;
    }
    curAmortizacion.setModeAccess(curAmortizacion.Edit);
    curAmortizacion.refreshBuffer();
    curAmortizacion.setValueBuffer("totalamortizado", formRecordco_amortizaciones.iface.pub_commonCalculateField("totalamortizado", curAmortizacion));
    curAmortizacion.setValueBuffer("pendiente", formRecordco_amortizaciones.iface.pub_commonCalculateField("pendiente", curAmortizacion));
    curAmortizacion.setValueBuffer("estado", formRecordco_amortizaciones.iface.pub_commonCalculateField("estado", curAmortizacion));
    if (!curAmortizacion.commitBuffer()) {
      return false;
    }
    //    fechaUltimaDot = util.sqlSelect("co_dotaciones", "fechafin", "codamortizacion = '" + codAmor + "' ORDER BY fechafin DESC");
    //    dotCompletas = (util.daysTo(fechaUltimaDot, fechaLimite) <= 0);
    pendiente = parseFloat(util.sqlSelect("co_amortizaciones", "pendiente", "codamortizacion = '" + codAmor + "'"));
    pendiente = (isNaN(pendiente) ? 0 : pendiente);
    this.iface.numDotaciones_++;
  }
  return true;
}
function filtrarTabla4()
{
  var filtro = this.iface.filtroTabla();
  this.cursor().setMainFilter(filtro);
  return true;
}
function filtroTabla5()
{
  var filtro = "";
  return filtro;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
