//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_planasientos.qs  -  description
-------------------
begin                : lun mar 27 2006
copyright            : (C) 2006 by InfoSiAL S.L. y Guillermo Molleda Jimena
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var tdbPlanPartidas: FLTableDB;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
}
const iface = new interna(this);
/** \C Los nuevos asientos creados pertencen al ejercicio vigente en el momento de crearlos
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.tdbPlanPartidas = this.child("tdbPlanPartidas");
  flcontppal.iface.pub_clearPreMemoria();
  var tipoPredefinido = this.child("fdbPreasiento").value().toString();
  var curPlanPartidas = new FLSqlCursor("co_planpartidas");
  curPlanPartidas.select("codplanasiento = '" + tipoPredefinido + "' ORDER BY numorden");
  var totalPlanpartidas = curPlanPartidas.size();
  var nombreMem = "";
  if (cursor.modeAccess() == cursor.Edit) {
    for (var contador = 0; contador < totalPlanpartidas; contador++) {
      curPlanPartidas.next();
      curPlanPartidas.setModeAccess(curPlanPartidas.Browse);
      curPlanPartidas.refreshBuffer();
      nombreMem = curPlanPartidas.valueBuffer("nsubcuenta").toString();
      if (nombreMem != "") {
        flcontppal.iface.pub_putPreMemoria(nombreMem, "Subcuenta");
      }
      nombreMem = curPlanPartidas.valueBuffer("nimporte").toString();
      if (nombreMem != "") {
        flcontppal.iface.pub_putPreMemoria(nombreMem, "Importe");
      }
      nombreMem = curPlanPartidas.valueBuffer("nconcepto").toString();
      if (nombreMem != "") {
        flcontppal.iface.pub_putPreMemoria(nombreMem, "Concepto");
      }
      nombreMem = curPlanPartidas.valueBuffer("ncontrapartida").toString();
      if (nombreMem != "") {
        flcontppal.iface.pub_putPreMemoria(nombreMem, "Subcuenta");
      }
      nombreMem = curPlanPartidas.valueBuffer("nbaseimponible").toString();
      if (nombreMem != "") {
        flcontppal.iface.pub_putPreMemoria(nombreMem, "Importe");
      }
      nombreMem = curPlanPartidas.valueBuffer("nimporteme").toString();
      if (nombreMem != "") {
        flcontppal.iface.pub_putPreMemoria(nombreMem, "Importe");
      }
    }
  }
}
/** \C El asiento predefinido deber liberar la memoria utilizada
\end */
function validateForm1()
{
  flcontppal.iface.pub_clearPreMemoria();
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
